#include <config.h>
#include <tuneconfig.h>
/* card_painter.c generated by valac 0.42.5, the Vala compiler
 * generated from card_painter.vala, do not modify */

/* tarot implements the rules of the tarot game*/
/* Copyright (C) 2017, 2018, 2019  Vivien Kraus*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, either version 3 of the License, or (at*/
/* your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/


#include <glib.h>
#include <glib-object.h>
#include "tarot-gobject.h"
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TAROT_CAIRO_TYPE_CARD_PAINTER (tarot_cairo_card_painter_get_type ())
#define TAROT_CAIRO_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER, TarotCairoCardPainter))
#define TAROT_CAIRO_IS_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER))
#define TAROT_CAIRO_CARD_PAINTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER, TarotCairoCardPainterIface))

typedef struct _TarotCairoCardPainter TarotCairoCardPainter;
typedef struct _TarotCairoCardPainterIface TarotCairoCardPainterIface;

#define TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE (tarot_cairo_card_painter_reference_get_type ())
#define TAROT_CAIRO_CARD_PAINTER_REFERENCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE, TarotCairoCardPainterReference))
#define TAROT_CAIRO_CARD_PAINTER_REFERENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE, TarotCairoCardPainterReferenceClass))
#define TAROT_CAIRO_CARD_PAINTER_IS_REFERENCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE))
#define TAROT_CAIRO_CARD_PAINTER_IS_REFERENCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE))
#define TAROT_CAIRO_CARD_PAINTER_REFERENCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE, TarotCairoCardPainterReferenceClass))

typedef struct _TarotCairoCardPainterReference TarotCairoCardPainterReference;
typedef struct _TarotCairoCardPainterReferenceClass TarotCairoCardPainterReferenceClass;
typedef struct _TarotCairoCardPainterReferencePrivate TarotCairoCardPainterReferencePrivate;
typedef struct _TarotCairoCardPainterParamSpecReference TarotCairoCardPainterParamSpecReference;

struct _TarotCairoCardPainterIface {
	GTypeInterface parent_iface;
	void (*paint_card) (TarotCairoCardPainter* self, TarotCard card, gboolean is_selected, gboolean is_selectable, cairo_t* context);
	gdouble (*get_card_width) (TarotCairoCardPainter* self);
	gdouble (*get_card_height) (TarotCairoCardPainter* self);
};

struct _TarotCairoCardPainterReference {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TarotCairoCardPainterReferencePrivate * priv;
	gsize index;
};

struct _TarotCairoCardPainterReferenceClass {
	GTypeClass parent_class;
	void (*finalize) (TarotCairoCardPainterReference *self);
};

struct _TarotCairoCardPainterParamSpecReference {
	GParamSpec parent_instance;
};


static gpointer tarot_cairo_card_painter_reference_parent_class = NULL;

GType tarot_cairo_card_painter_get_type (void) G_GNUC_CONST;
void tarot_cairo_card_painter_paint_card (TarotCairoCardPainter* self,
                                          TarotCard card,
                                          gboolean is_selected,
                                          gboolean is_selectable,
                                          cairo_t* context);
gdouble tarot_cairo_card_painter_get_card_width (TarotCairoCardPainter* self);
gdouble tarot_cairo_card_painter_get_card_height (TarotCairoCardPainter* self);
static gpointer tarot_cairo_card_painter_reference_ref (gpointer instance);
static void tarot_cairo_card_painter_reference_unref (gpointer instance);
static GParamSpec* tarot_cairo_card_painter_param_spec_reference (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags) G_GNUC_UNUSED;
static void tarot_cairo_card_painter_value_set_reference (GValue* value,
                                                   gpointer v_object) G_GNUC_UNUSED;
static void tarot_cairo_card_painter_value_take_reference (GValue* value,
                                                    gpointer v_object) G_GNUC_UNUSED;
static gpointer tarot_cairo_card_painter_value_get_reference (const GValue* value) G_GNUC_UNUSED;
static GType tarot_cairo_card_painter_reference_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static TarotCairoCardPainterReference* tarot_cairo_card_painter_reference_new (gsize i);
static TarotCairoCardPainterReference* tarot_cairo_card_painter_reference_construct (GType object_type,
                                                                              gsize i);
static void tarot_cairo_card_painter_reference_finalize (TarotCairoCardPainterReference * obj);


/**
 * Paint a card to the cairo context.  Usually this is simply
 * printing a pixmap of width given by the property
 * card_width.  The cards from 78 and up should be painted as
 * a card back.
 */
void
tarot_cairo_card_painter_paint_card (TarotCairoCardPainter* self,
                                     TarotCard card,
                                     gboolean is_selected,
                                     gboolean is_selectable,
                                     cairo_t* context)
{
	g_return_if_fail (self != NULL);
	TAROT_CAIRO_CARD_PAINTER_GET_INTERFACE (self)->paint_card (self, card, is_selected, is_selectable, context);
}


gdouble
tarot_cairo_card_painter_get_card_width (TarotCairoCardPainter* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return TAROT_CAIRO_CARD_PAINTER_GET_INTERFACE (self)->get_card_width (self);
}


gdouble
tarot_cairo_card_painter_get_card_height (TarotCairoCardPainter* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return TAROT_CAIRO_CARD_PAINTER_GET_INTERFACE (self)->get_card_height (self);
}


static TarotCairoCardPainterReference*
tarot_cairo_card_painter_reference_construct (GType object_type,
                                              gsize i)
{
	TarotCairoCardPainterReference* self = NULL;
	self = (TarotCairoCardPainterReference*) g_type_create_instance (object_type);
	self->index = i;
	return self;
}


static TarotCairoCardPainterReference*
tarot_cairo_card_painter_reference_new (gsize i)
{
	return tarot_cairo_card_painter_reference_construct (TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE, i);
}


static void
tarot_cairo_card_painter_value_reference_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}


static void
tarot_cairo_card_painter_value_reference_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		tarot_cairo_card_painter_reference_unref (value->data[0].v_pointer);
	}
}


static void
tarot_cairo_card_painter_value_reference_copy_value (const GValue* src_value,
                                                     GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = tarot_cairo_card_painter_reference_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer
tarot_cairo_card_painter_value_reference_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}


static gchar*
tarot_cairo_card_painter_value_reference_collect_value (GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		TarotCairoCardPainterReference * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = tarot_cairo_card_painter_reference_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar*
tarot_cairo_card_painter_value_reference_lcopy_value (const GValue* value,
                                                      guint n_collect_values,
                                                      GTypeCValue* collect_values,
                                                      guint collect_flags)
{
	TarotCairoCardPainterReference ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = tarot_cairo_card_painter_reference_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec*
tarot_cairo_card_painter_param_spec_reference (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags)
{
	TarotCairoCardPainterParamSpecReference* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer
tarot_cairo_card_painter_value_get_reference (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE), NULL);
	return value->data[0].v_pointer;
}


static void
tarot_cairo_card_painter_value_set_reference (GValue* value,
                                              gpointer v_object)
{
	TarotCairoCardPainterReference * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		tarot_cairo_card_painter_reference_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		tarot_cairo_card_painter_reference_unref (old);
	}
}


static void
tarot_cairo_card_painter_value_take_reference (GValue* value,
                                               gpointer v_object)
{
	TarotCairoCardPainterReference * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		tarot_cairo_card_painter_reference_unref (old);
	}
}


static void
tarot_cairo_card_painter_reference_class_init (TarotCairoCardPainterReferenceClass * klass)
{
	tarot_cairo_card_painter_reference_parent_class = g_type_class_peek_parent (klass);
	((TarotCairoCardPainterReferenceClass *) klass)->finalize = tarot_cairo_card_painter_reference_finalize;
}


static void
tarot_cairo_card_painter_reference_instance_init (TarotCairoCardPainterReference * self)
{
	self->ref_count = 1;
}


static void
tarot_cairo_card_painter_reference_finalize (TarotCairoCardPainterReference * obj)
{
	TarotCairoCardPainterReference * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_CAIRO_CARD_PAINTER_TYPE_REFERENCE, TarotCairoCardPainterReference);
	g_signal_handlers_destroy (self);
}


static GType
tarot_cairo_card_painter_reference_get_type (void)
{
	static volatile gsize tarot_cairo_card_painter_reference_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_cairo_card_painter_reference_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { tarot_cairo_card_painter_value_reference_init, tarot_cairo_card_painter_value_reference_free_value, tarot_cairo_card_painter_value_reference_copy_value, tarot_cairo_card_painter_value_reference_peek_pointer, "p", tarot_cairo_card_painter_value_reference_collect_value, "p", tarot_cairo_card_painter_value_reference_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TarotCairoCardPainterReferenceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_cairo_card_painter_reference_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotCairoCardPainterReference), 0, (GInstanceInitFunc) tarot_cairo_card_painter_reference_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType tarot_cairo_card_painter_reference_type_id;
		tarot_cairo_card_painter_reference_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TarotCairoCardPainterReference", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&tarot_cairo_card_painter_reference_type_id__volatile, tarot_cairo_card_painter_reference_type_id);
	}
	return tarot_cairo_card_painter_reference_type_id__volatile;
}


static gpointer
tarot_cairo_card_painter_reference_ref (gpointer instance)
{
	TarotCairoCardPainterReference * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void
tarot_cairo_card_painter_reference_unref (gpointer instance)
{
	TarotCairoCardPainterReference * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TAROT_CAIRO_CARD_PAINTER_REFERENCE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void
tarot_cairo_card_painter_default_init (TarotCairoCardPainterIface * iface)
{
	g_object_interface_install_property (iface, g_param_spec_double ("card-width", "card-width", "card-width", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_interface_install_property (iface, g_param_spec_double ("card-height", "card-height", "card-height", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


GType
tarot_cairo_card_painter_get_type (void)
{
	static volatile gsize tarot_cairo_card_painter_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_cairo_card_painter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotCairoCardPainterIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_cairo_card_painter_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType tarot_cairo_card_painter_type_id;
		tarot_cairo_card_painter_type_id = g_type_register_static (G_TYPE_INTERFACE, "TarotCairoCardPainter", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (tarot_cairo_card_painter_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&tarot_cairo_card_painter_type_id__volatile, tarot_cairo_card_painter_type_id);
	}
	return tarot_cairo_card_painter_type_id__volatile;
}



