#include <config.h>
#include <tuneconfig.h>
/* card_painter_default.c generated by valac 0.42.5, the Vala compiler
 * generated from card_painter_default.vala, do not modify */

/* tarot implements the rules of the tarot game*/
/* Copyright (C) 2017, 2018, 2019  Vivien Kraus*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, either version 3 of the License, or (at*/
/* your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/


#include <glib.h>
#include <glib-object.h>
#include "tarot-gobject.h"
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TAROT_CAIRO_TYPE_CARD_PAINTER (tarot_cairo_card_painter_get_type ())
#define TAROT_CAIRO_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER, TarotCairoCardPainter))
#define TAROT_CAIRO_IS_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER))
#define TAROT_CAIRO_CARD_PAINTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TAROT_CAIRO_TYPE_CARD_PAINTER, TarotCairoCardPainterIface))

typedef struct _TarotCairoCardPainter TarotCairoCardPainter;
typedef struct _TarotCairoCardPainterIface TarotCairoCardPainterIface;

#define TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER (tarot_cairo_default_card_painter_get_type ())
#define TAROT_CAIRO_DEFAULT_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainter))
#define TAROT_CAIRO_DEFAULT_CARD_PAINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainterClass))
#define TAROT_CAIRO_IS_DEFAULT_CARD_PAINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER))
#define TAROT_CAIRO_IS_DEFAULT_CARD_PAINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER))
#define TAROT_CAIRO_DEFAULT_CARD_PAINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainterClass))

typedef struct _TarotCairoDefaultCardPainter TarotCairoDefaultCardPainter;
typedef struct _TarotCairoDefaultCardPainterClass TarotCairoDefaultCardPainterClass;
typedef struct _TarotCairoDefaultCardPainterPrivate TarotCairoDefaultCardPainterPrivate;
enum  {
	TAROT_CAIRO_DEFAULT_CARD_PAINTER_0_PROPERTY,
	TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_WIDTH_PROPERTY,
	TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_HEIGHT_PROPERTY,
	TAROT_CAIRO_DEFAULT_CARD_PAINTER_NUM_PROPERTIES
};
static GParamSpec* tarot_cairo_default_card_painter_properties[TAROT_CAIRO_DEFAULT_CARD_PAINTER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TarotCairoCardPainterIface {
	GTypeInterface parent_iface;
	void (*paint_card) (TarotCairoCardPainter* self, TarotCard card, gboolean is_selected, gboolean is_selectable, cairo_t* context);
	gdouble (*get_card_width) (TarotCairoCardPainter* self);
	gdouble (*get_card_height) (TarotCairoCardPainter* self);
};

struct _TarotCairoDefaultCardPainter {
	GObject parent_instance;
	TarotCairoDefaultCardPainterPrivate * priv;
	gdouble border_width;
};

struct _TarotCairoDefaultCardPainterClass {
	GObjectClass parent_class;
};

struct _TarotCairoDefaultCardPainterPrivate {
	gdouble _card_width;
	gdouble _card_height;
};


static gint TarotCairoDefaultCardPainter_private_offset;
static gpointer tarot_cairo_default_card_painter_parent_class = NULL;
static TarotCairoCardPainterIface * tarot_cairo_default_card_painter_tarot_cairo_card_painter_parent_iface = NULL;

GType tarot_cairo_card_painter_get_type (void) G_GNUC_CONST;
GType tarot_cairo_default_card_painter_get_type (void) G_GNUC_CONST;
static void tarot_cairo_default_card_painter_paint_border (TarotCairoDefaultCardPainter* self,
                                                    gboolean selected,
                                                    gboolean selectable,
                                                    cairo_t* context);
gdouble tarot_cairo_card_painter_get_card_width (TarotCairoCardPainter* self);
gdouble tarot_cairo_card_painter_get_card_height (TarotCairoCardPainter* self);
static void tarot_cairo_default_card_painter_paint_back (TarotCairoDefaultCardPainter* self,
                                                  cairo_t* context);
static void tarot_cairo_default_card_painter_paint_number_and_suit (TarotCairoDefaultCardPainter* self,
                                                             cairo_t* context,
                                                             const gchar* number,
                                                             const gchar* suit,
                                                             gint color);
static void tarot_cairo_default_card_painter_real_paint_card (TarotCairoCardPainter* base,
                                                       TarotCard card,
                                                       gboolean selected,
                                                       gboolean selectable,
                                                       cairo_t* context);
TarotCairoDefaultCardPainter* tarot_cairo_default_card_painter_new (void);
TarotCairoDefaultCardPainter* tarot_cairo_default_card_painter_construct (GType object_type);
static void tarot_cairo_default_card_painter_finalize (GObject * obj);
static void _vala_tarot_cairo_default_card_painter_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);


static inline gpointer
tarot_cairo_default_card_painter_get_instance_private (TarotCairoDefaultCardPainter* self)
{
	return G_STRUCT_MEMBER_P (self, TarotCairoDefaultCardPainter_private_offset);
}


static void
tarot_cairo_default_card_painter_paint_border (TarotCairoDefaultCardPainter* self,
                                               gboolean selected,
                                               gboolean selectable,
                                               cairo_t* context)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp3_ = _tmp2_;
	cairo_translate (context, (-_tmp1_) / 2, (-_tmp3_) / 2);
	_tmp4_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp7_ = _tmp6_;
	cairo_rectangle (context, (gdouble) 0, (gdouble) 0, _tmp5_, _tmp7_);
	_tmp8_ = self->border_width;
	cairo_set_line_width (context, _tmp8_);
	if (selected) {
		cairo_set_source_rgb (context, 0.988, 0.914, 0.31);
	} else {
		if (selectable) {
			cairo_set_source_rgb (context, 0.933, 0.933, 0.925);
		} else {
			cairo_set_source_rgb (context, 0.827, 0.843, 0.812);
		}
	}
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) 0);
	_tmp9_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp10_ = _tmp9_;
	cairo_line_to (context, (gdouble) 0, _tmp10_);
	_tmp11_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp12_ = _tmp11_;
	_tmp13_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp14_ = _tmp13_;
	cairo_line_to (context, _tmp12_, _tmp14_);
	_tmp15_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp16_ = _tmp15_;
	cairo_line_to (context, _tmp16_, (gdouble) 0);
	cairo_line_to (context, (gdouble) 0, (gdouble) 0);
	cairo_set_source_rgb (context, 0.18, 0.204, 0.212);
	cairo_stroke (context);
}


static void
tarot_cairo_default_card_painter_paint_back (TarotCairoDefaultCardPainter* self,
                                             cairo_t* context)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	tarot_cairo_default_card_painter_paint_border (self, FALSE, FALSE, context);
	_tmp0_ = tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp3_ = _tmp2_;
	cairo_rectangle (context, (gdouble) 0, (gdouble) 0, _tmp1_, _tmp3_);
	cairo_set_source_rgb (context, 0.333, 0.341, 0.325);
	cairo_fill (context);
}


static void
tarot_cairo_default_card_painter_paint_number_and_suit (TarotCairoDefaultCardPainter* self,
                                                        cairo_t* context,
                                                        const gchar* number,
                                                        const gchar* suit,
                                                        gint color)
{
	gint font_size = 0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (number != NULL);
	g_return_if_fail (suit != NULL);
	switch (color) {
		case 0:
		{
			cairo_set_source_rgb (context, 0.18, 0.204, 0.212);
			break;
		}
		case 1:
		{
			cairo_set_source_rgb (context, 0.643, (gdouble) 0, (gdouble) 0);
			break;
		}
		case 2:
		{
			cairo_set_source_rgb (context, 0.125, 0.29, 0.529);
			break;
		}
		default:
		break;
	}
	font_size = 4;
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	cairo_set_font_size (context, (gdouble) font_size);
	cairo_scale (context, (gdouble) 1, (gdouble) -1);
	_tmp0_ = tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self);
	_tmp1_ = _tmp0_;
	cairo_translate (context, (gdouble) 1, (-_tmp1_) + font_size);
	cairo_show_text (context, number);
	cairo_move_to (context, (gdouble) 0, (gdouble) font_size);
	cairo_show_text (context, suit);
	cairo_move_to (context, (gdouble) 6, (gdouble) 12);
	cairo_set_font_size (context, (gdouble) 14);
	cairo_show_text (context, number);
	cairo_move_to (context, (gdouble) 6, (gdouble) 32);
	cairo_show_text (context, suit);
}


static void
tarot_cairo_default_card_painter_real_paint_card (TarotCairoCardPainter* base,
                                                  TarotCard card,
                                                  gboolean selected,
                                                  gboolean selectable,
                                                  cairo_t* context)
{
	TarotCairoDefaultCardPainter * self;
	self = (TarotCairoDefaultCardPainter*) base;
	g_return_if_fail (context != NULL);
	if (card < ((TarotCard) 78)) {
		TarotNumber n = 0U;
		TarotSuit s = 0;
		gchar* number = NULL;
		gchar* _tmp0_;
		gchar* suit = NULL;
		gchar* _tmp1_;
		gint color = 0;
		TarotNumber _tmp2_ = 0U;
		TarotSuit _tmp3_ = 0;
		gint _tmp4_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gint _tmp23_;
		tarot_cairo_default_card_painter_paint_border (self, selected, selectable, context);
		_tmp0_ = g_strdup (_ ("EXC"));
		number = _tmp0_;
		_tmp1_ = g_strdup ("*");
		suit = _tmp1_;
		color = 2;
		_tmp4_ = tarot_decompose (card, &_tmp2_, &_tmp3_);
		n = _tmp2_;
		s = _tmp3_;
		if (_tmp4_ == 0) {
			TarotSuit _tmp5_;
			_tmp5_ = s;
			if (_tmp5_ == TAROT_TRUMPS) {
				gchar* _tmp6_;
				TarotNumber _tmp7_;
				gchar* _tmp8_;
				_tmp6_ = g_strdup ("#");
				_g_free0 (suit);
				suit = _tmp6_;
				color = 2;
				_tmp7_ = n;
				_tmp8_ = g_strdup_printf ("%u", (guint) _tmp7_);
				_g_free0 (number);
				number = _tmp8_;
			} else {
				TarotSuit _tmp9_;
				TarotNumber _tmp14_;
				gchar* _tmp15_;
				TarotNumber _tmp16_;
				_tmp9_ = s;
				switch (_tmp9_) {
					case TAROT_HEARTS:
					{
						gchar* _tmp10_;
						_tmp10_ = g_strdup ("♥");
						_g_free0 (suit);
						suit = _tmp10_;
						color = 1;
						break;
					}
					case TAROT_CLUBS:
					{
						gchar* _tmp11_;
						_tmp11_ = g_strdup ("♣");
						_g_free0 (suit);
						suit = _tmp11_;
						color = 0;
						break;
					}
					case TAROT_DIAMONDS:
					{
						gchar* _tmp12_;
						_tmp12_ = g_strdup ("♦");
						_g_free0 (suit);
						suit = _tmp12_;
						color = 1;
						break;
					}
					case TAROT_SPADES:
					{
						gchar* _tmp13_;
						_tmp13_ = g_strdup ("♠");
						_g_free0 (suit);
						suit = _tmp13_;
						color = 0;
						break;
					}
					default:
					break;
				}
				_tmp14_ = n;
				_tmp15_ = g_strdup_printf ("%u", (guint) _tmp14_);
				_g_free0 (number);
				number = _tmp15_;
				_tmp16_ = n;
				switch (_tmp16_) {
					case 11:
					{
						gchar* _tmp17_;
						_tmp17_ = g_strdup (_ ("J"));
						_g_free0 (number);
						number = _tmp17_;
						break;
					}
					case 12:
					{
						gchar* _tmp18_;
						_tmp18_ = g_strdup (_ ("C"));
						_g_free0 (number);
						number = _tmp18_;
						break;
					}
					case 13:
					{
						gchar* _tmp19_;
						_tmp19_ = g_strdup (_ ("Q"));
						_g_free0 (number);
						number = _tmp19_;
						break;
					}
					case 14:
					{
						gchar* _tmp20_;
						_tmp20_ = g_strdup (_ ("K"));
						_g_free0 (number);
						number = _tmp20_;
						break;
					}
					default:
					break;
				}
			}
		}
		_tmp21_ = number;
		_tmp22_ = suit;
		_tmp23_ = color;
		tarot_cairo_default_card_painter_paint_number_and_suit (self, context, _tmp21_, _tmp22_, _tmp23_);
		_g_free0 (suit);
		_g_free0 (number);
	} else {
		if (card == ((TarotCard) 78)) {
			tarot_cairo_default_card_painter_paint_back (self, context);
		}
	}
}


TarotCairoDefaultCardPainter*
tarot_cairo_default_card_painter_construct (GType object_type)
{
	TarotCairoDefaultCardPainter * self = NULL;
	self = (TarotCairoDefaultCardPainter*) g_object_new (object_type, NULL);
	return self;
}


TarotCairoDefaultCardPainter*
tarot_cairo_default_card_painter_new (void)
{
	return tarot_cairo_default_card_painter_construct (TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER);
}


static gdouble
tarot_cairo_default_card_painter_real_get_card_width (TarotCairoCardPainter* base)
{
	gdouble result;
	TarotCairoDefaultCardPainter* self;
	gdouble _tmp0_;
	self = (TarotCairoDefaultCardPainter*) base;
	_tmp0_ = self->priv->_card_width;
	result = _tmp0_;
	return result;
}


static gdouble
tarot_cairo_default_card_painter_real_get_card_height (TarotCairoCardPainter* base)
{
	gdouble result;
	TarotCairoDefaultCardPainter* self;
	gdouble _tmp0_;
	self = (TarotCairoDefaultCardPainter*) base;
	_tmp0_ = self->priv->_card_height;
	result = _tmp0_;
	return result;
}


static void
tarot_cairo_default_card_painter_class_init (TarotCairoDefaultCardPainterClass * klass)
{
	tarot_cairo_default_card_painter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TarotCairoDefaultCardPainter_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tarot_cairo_default_card_painter_get_property;
	G_OBJECT_CLASS (klass)->finalize = tarot_cairo_default_card_painter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_WIDTH_PROPERTY, tarot_cairo_default_card_painter_properties[TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_WIDTH_PROPERTY] = g_param_spec_double ("card-width", "card-width", "card-width", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_HEIGHT_PROPERTY, tarot_cairo_default_card_painter_properties[TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_HEIGHT_PROPERTY] = g_param_spec_double ("card-height", "card-height", "card-height", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
tarot_cairo_default_card_painter_tarot_cairo_card_painter_interface_init (TarotCairoCardPainterIface * iface)
{
	tarot_cairo_default_card_painter_tarot_cairo_card_painter_parent_iface = g_type_interface_peek_parent (iface);
	iface->paint_card = (void (*) (TarotCairoCardPainter*, TarotCard, gboolean, gboolean, cairo_t*)) tarot_cairo_default_card_painter_real_paint_card;
	iface->get_card_width = tarot_cairo_default_card_painter_real_get_card_width;
	iface->get_card_height = tarot_cairo_default_card_painter_real_get_card_height;
}


static void
tarot_cairo_default_card_painter_instance_init (TarotCairoDefaultCardPainter * self)
{
	self->priv = tarot_cairo_default_card_painter_get_instance_private (self);
	self->priv->_card_width = (gdouble) 32;
	self->priv->_card_height = (gdouble) 48;
	self->border_width = (gdouble) 1;
}


static void
tarot_cairo_default_card_painter_finalize (GObject * obj)
{
	TarotCairoDefaultCardPainter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainter);
	G_OBJECT_CLASS (tarot_cairo_default_card_painter_parent_class)->finalize (obj);
}


GType
tarot_cairo_default_card_painter_get_type (void)
{
	static volatile gsize tarot_cairo_default_card_painter_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_cairo_default_card_painter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotCairoDefaultCardPainterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_cairo_default_card_painter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotCairoDefaultCardPainter), 0, (GInstanceInitFunc) tarot_cairo_default_card_painter_instance_init, NULL };
		static const GInterfaceInfo tarot_cairo_card_painter_info = { (GInterfaceInitFunc) tarot_cairo_default_card_painter_tarot_cairo_card_painter_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType tarot_cairo_default_card_painter_type_id;
		tarot_cairo_default_card_painter_type_id = g_type_register_static (G_TYPE_OBJECT, "TarotCairoDefaultCardPainter", &g_define_type_info, 0);
		g_type_add_interface_static (tarot_cairo_default_card_painter_type_id, TAROT_CAIRO_TYPE_CARD_PAINTER, &tarot_cairo_card_painter_info);
		TarotCairoDefaultCardPainter_private_offset = g_type_add_instance_private (tarot_cairo_default_card_painter_type_id, sizeof (TarotCairoDefaultCardPainterPrivate));
		g_once_init_leave (&tarot_cairo_default_card_painter_type_id__volatile, tarot_cairo_default_card_painter_type_id);
	}
	return tarot_cairo_default_card_painter_type_id__volatile;
}


static void
_vala_tarot_cairo_default_card_painter_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	TarotCairoDefaultCardPainter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_CAIRO_TYPE_DEFAULT_CARD_PAINTER, TarotCairoDefaultCardPainter);
	switch (property_id) {
		case TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_WIDTH_PROPERTY:
		g_value_set_double (value, tarot_cairo_card_painter_get_card_width ((TarotCairoCardPainter*) self));
		break;
		case TAROT_CAIRO_DEFAULT_CARD_PAINTER_CARD_HEIGHT_PROPERTY:
		g_value_set_double (value, tarot_cairo_card_painter_get_card_height ((TarotCairoCardPainter*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



