#include <config.h>
#include <tuneconfig.h>
/* widget.c generated by valac 0.42.5, the Vala compiler
 * generated from widget.vala, do not modify */

/* tarot implements the rules of the tarot game*/
/* Copyright (C) 2019  Vivien Kraus*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, either version 3 of the License, or (at*/
/* your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "tarot-gobject.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdio.h>


#define TAROT_TYPE_WIDGET (tarot_widget_get_type ())
#define TAROT_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_WIDGET, TarotWidget))
#define TAROT_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_WIDGET, TarotWidgetClass))
#define TAROT_IS_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_WIDGET))
#define TAROT_IS_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_WIDGET))
#define TAROT_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_WIDGET, TarotWidgetClass))

typedef struct _TarotWidget TarotWidget;
typedef struct _TarotWidgetClass TarotWidgetClass;
typedef struct _TarotWidgetPrivate TarotWidgetPrivate;

#define TAROT_TYPE_CARD_VIEW (tarot_card_view_get_type ())
#define TAROT_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_CARD_VIEW, TarotCardView))
#define TAROT_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_CARD_VIEW, TarotCardViewClass))
#define TAROT_IS_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_CARD_VIEW))
#define TAROT_IS_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_CARD_VIEW))
#define TAROT_CARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_CARD_VIEW, TarotCardViewClass))

typedef struct _TarotCardView TarotCardView;
typedef struct _TarotCardViewClass TarotCardViewClass;

#define TAROT_TYPE_TRICK_CARD_VIEW (tarot_trick_card_view_get_type ())
#define TAROT_TRICK_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_TRICK_CARD_VIEW, TarotTrickCardView))
#define TAROT_TRICK_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_TRICK_CARD_VIEW, TarotTrickCardViewClass))
#define TAROT_IS_TRICK_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_TRICK_CARD_VIEW))
#define TAROT_IS_TRICK_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_TRICK_CARD_VIEW))
#define TAROT_TRICK_CARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_TRICK_CARD_VIEW, TarotTrickCardViewClass))

typedef struct _TarotTrickCardView TarotTrickCardView;
typedef struct _TarotTrickCardViewClass TarotTrickCardViewClass;

#define TAROT_TYPE_CENTER_CARD_VIEW (tarot_center_card_view_get_type ())
#define TAROT_CENTER_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_CENTER_CARD_VIEW, TarotCenterCardView))
#define TAROT_CENTER_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_CENTER_CARD_VIEW, TarotCenterCardViewClass))
#define TAROT_IS_CENTER_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_CENTER_CARD_VIEW))
#define TAROT_IS_CENTER_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_CENTER_CARD_VIEW))
#define TAROT_CENTER_CARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_CENTER_CARD_VIEW, TarotCenterCardViewClass))

typedef struct _TarotCenterCardView TarotCenterCardView;
typedef struct _TarotCenterCardViewClass TarotCenterCardViewClass;

#define TAROT_TYPE_FAN_CARD_VIEW (tarot_fan_card_view_get_type ())
#define TAROT_FAN_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_FAN_CARD_VIEW, TarotFanCardView))
#define TAROT_FAN_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_FAN_CARD_VIEW, TarotFanCardViewClass))
#define TAROT_IS_FAN_CARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_FAN_CARD_VIEW))
#define TAROT_IS_FAN_CARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_FAN_CARD_VIEW))
#define TAROT_FAN_CARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_FAN_CARD_VIEW, TarotFanCardViewClass))

typedef struct _TarotFanCardView TarotFanCardView;
typedef struct _TarotFanCardViewClass TarotFanCardViewClass;

#define TAROT_TYPE_CARD_SELECTION (tarot_card_selection_get_type ())
#define TAROT_CARD_SELECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_CARD_SELECTION, TarotCardSelection))
#define TAROT_CARD_SELECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_CARD_SELECTION, TarotCardSelectionClass))
#define TAROT_IS_CARD_SELECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_CARD_SELECTION))
#define TAROT_IS_CARD_SELECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_CARD_SELECTION))
#define TAROT_CARD_SELECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_CARD_SELECTION, TarotCardSelectionClass))

typedef struct _TarotCardSelection TarotCardSelection;
typedef struct _TarotCardSelectionClass TarotCardSelectionClass;
enum  {
	TAROT_WIDGET_0_PROPERTY,
	TAROT_WIDGET_GAME_PROPERTY,
	TAROT_WIDGET_NUM_PROPERTIES
};
static GParamSpec* tarot_widget_properties[TAROT_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_TarotGame_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGame_free (var), NULL)))
#define __vala_TarotGameEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGameEvent_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	TAROT_WIDGET_SELECT_BID_SIGNAL,
	TAROT_WIDGET_SELECT_DECLARATION_SIGNAL,
	TAROT_WIDGET_SELECT_CALL_SIGNAL,
	TAROT_WIDGET_SELECT_DISCARD_SIGNAL,
	TAROT_WIDGET_SELECT_HANDFUL_SIGNAL,
	TAROT_WIDGET_SELECT_CARD_SIGNAL,
	TAROT_WIDGET_NUM_SIGNALS
};
static guint tarot_widget_signals[TAROT_WIDGET_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TarotWidget {
	GtkBox parent_instance;
	TarotWidgetPrivate * priv;
};

struct _TarotWidgetClass {
	GtkBoxClass parent_class;
};

struct _TarotWidgetPrivate {
	TarotTrickCardView* trick_widget;
	TarotCenterCardView* center_widget;
	TarotFanCardView* hand_widget;
	GtkStack* entry_stack;
	GtkFlowBox* widget_bid;
	GtkButton* button_take;
	GtkButton* button_push;
	GtkButton* button_straight_keep;
	GtkButton* button_double_keep;
	GtkLabel* player_information_myself;
	GtkBox* widget_decl;
	GtkButton* button_slam;
	GtkBox* widget_call;
	TarotCardSelection* call_selection;
	GtkButton* button_call;
	GtkBox* widget_discard;
	TarotCardSelection* discard_selection;
	GtkButton* button_discard;
	GtkBox* widget_handful;
	TarotCardSelection* handful_selection;
	GtkButton* button_handful;
	gboolean allow_play;
	TarotGame* current_game;
	GtkTreeView* player_information_others;
	GtkLabel* call_info;
};


static gint TarotWidget_private_offset;
static gpointer tarot_widget_parent_class = NULL;

GType tarot_widget_get_type (void) G_GNUC_CONST;
GType tarot_card_view_get_type (void) G_GNUC_CONST;
GType tarot_trick_card_view_get_type (void) G_GNUC_CONST;
GType tarot_center_card_view_get_type (void) G_GNUC_CONST;
GType tarot_fan_card_view_get_type (void) G_GNUC_CONST;
GType tarot_card_selection_get_type (void) G_GNUC_CONST;
static void _vala_TarotGame_free (TarotGame* self);
static void tarot_widget_select_pass (TarotWidget* self);
void tarot_widget_dont_ask (TarotWidget* self);
static void _tarot_widget_select_pass_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_take (TarotWidget* self);
static void _tarot_widget_select_take_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_push (TarotWidget* self);
static void _tarot_widget_select_push_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_straight_keep (TarotWidget* self);
static void _tarot_widget_select_straight_keep_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void tarot_widget_select_double_keep (TarotWidget* self);
static void _tarot_widget_select_double_keep_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void tarot_widget_select_none (TarotWidget* self);
static void _tarot_widget_select_none_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_select_slam (TarotWidget* self);
static void _tarot_widget_select_slam_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_widget_button_call_clicked (TarotWidget* self);
TarotCard* tarot_card_selection_get_selection (TarotCardSelection* self,
                                               int* result_length1);
static void _tarot_widget_button_call_clicked_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void tarot_widget_valid_call_selection (TarotWidget* self);
static void _tarot_widget_valid_call_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                              gpointer self);
static void tarot_widget_invalid_call_selection (TarotWidget* self);
static void _tarot_widget_invalid_call_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                  gpointer self);
static void tarot_widget_button_discard_clicked (TarotWidget* self);
static void _tarot_widget_button_discard_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void tarot_widget_valid_discard_selection (TarotWidget* self);
static void _tarot_widget_valid_discard_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                                 gpointer self);
static void tarot_widget_invalid_discard_selection (TarotWidget* self);
static void _tarot_widget_invalid_discard_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                     gpointer self);
static void tarot_widget_button_handful_clicked (TarotWidget* self);
static void _tarot_widget_button_handful_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void tarot_widget_valid_handful_selection (TarotWidget* self);
static void _vala_TarotGameEvent_free (TarotGameEvent* self);
static void _tarot_widget_valid_handful_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                                 gpointer self);
static void tarot_widget_invalid_handful_selection (TarotWidget* self);
static void _tarot_widget_invalid_handful_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                     gpointer self);
void tarot_widget_ask_bid (TarotWidget* self,
                           TarotBid minimum);
void tarot_widget_ask_declaration (TarotWidget* self,
                                   gboolean allowed);
void tarot_widget_ask_call (TarotWidget* self,
                            TarotNumber mini);
static void _vala_array_add3 (TarotCard* * array,
                       int* length,
                       int* size,
                       TarotCard value);
void tarot_card_selection_set_forced (TarotCardSelection* self,
                                      TarotCard* forced_cards,
                                      int forced_cards_length1);
void tarot_card_selection_set_optional (TarotCardSelection* self,
                                        TarotCard* optional_cards,
                                        int optional_cards_length1);
void tarot_card_selection_set_n_optional (TarotCardSelection* self,
                                          gsize n);
void tarot_widget_ask_discard (TarotWidget* self,
                               gsize n,
                               TarotCard* prio,
                               int prio_length1,
                               TarotCard* additional,
                               int additional_length1);
static TarotCard* _vala_array_dup1 (TarotCard* self,
                             int length);
static TarotCard* _vala_array_dup2 (TarotCard* self,
                             int length);
static TarotCard* _vala_array_dup3 (TarotCard* self,
                             int length);
void tarot_widget_ask_handful (TarotWidget* self,
                               gsize n_simple,
                               gsize n_double,
                               gsize n_triple,
                               TarotCard* prio,
                               int prio_length1,
                               TarotCard* additional,
                               int additional_length1);
static TarotCard* _vala_array_dup4 (TarotCard* self,
                             int length);
static void _vala_array_add4 (TarotCard* * array,
                       int* length,
                       int* size,
                       TarotCard value);
void tarot_widget_ask_play (TarotWidget* self,
                            TarotCard* playable,
                            int playable_length1);
TarotCard* tarot_card_view_get_cards (TarotCardView* self,
                                      int* result_length1);
static void _vala_array_add5 (gsize* * array,
                       int* length,
                       int* size,
                       gsize value);
void tarot_card_view_set_selectable (TarotCardView* self,
                                     gsize* value,
                                     int value_length1);
static gchar* tarot_widget_compute_my_status_with_score (TarotWidget* self);
static gchar* tarot_widget_compute_my_status (TarotWidget* self,
                                       TarotPlayer myself);
static void tarot_widget_update_header_model (TarotWidget* self);
static TarotCard* tarot_widget_trick_content_aux (TarotWidget* self,
                                           TarotPlayer view,
                                           TarotPlayer* trick_taker,
                                           gsize trick,
                                           int* result_length1);
static TarotCard* tarot_widget_trick_content (TarotWidget* self,
                                       TarotPlayer view,
                                       TarotPlayer* trick_taker,
                                       int* result_length1);
static TarotCard* tarot_widget_center_content (TarotWidget* self,
                                        int* result_length1);
static void tarot_widget_update (TarotWidget* self);
static void _vala_array_add6 (TarotCard* * array,
                       int* length,
                       int* size,
                       TarotCard value);
void tarot_card_view_set_cards (TarotCardView* self,
                                TarotCard* value,
                                int value_length1);
void tarot_card_view_set_selection (TarotCardView* self,
                                    gsize* value,
                                    int value_length1);
static void tarot_widget_card_selected (TarotWidget* self,
                                 gsize i_card);
static void tarot_widget_no_card_selected (TarotWidget* self);
TarotWidget* tarot_widget_new (void);
TarotWidget* tarot_widget_construct (GType object_type);
TarotGame* tarot_widget_get_game (TarotWidget* self);
void tarot_widget_set_game (TarotWidget* self,
                            TarotGame* value);
static TarotGame* _vala_TarotGame_copy (TarotGame* self);
static void g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * tarot_widget_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static gboolean _tarot_widget___lambda21_ (TarotWidget* self,
                                    GdkEventMotion* motion,
                                    gsize i_card);
void tarot_card_view_set_pointed (TarotCardView* self,
                                  gsize* value);
static gboolean __tarot_widget___lambda21__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                              GdkEventMotion* motion,
                                                                              gsize index,
                                                                              gpointer self);
static gboolean _tarot_widget___lambda22_ (TarotWidget* self,
                                    GdkEventMotion* motion);
static gboolean __tarot_widget___lambda22__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                                 GdkEventMotion* motion,
                                                                                 gpointer self);
static gboolean _tarot_widget___lambda23_ (TarotWidget* self,
                                    GdkEventMotion* motion,
                                    gsize i_card);
static gboolean __tarot_widget___lambda23__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                              GdkEventMotion* motion,
                                                                              gsize index,
                                                                              gpointer self);
static gboolean _tarot_widget___lambda24_ (TarotWidget* self,
                                    GdkEventMotion* motion);
static gboolean __tarot_widget___lambda24__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                                 GdkEventMotion* motion,
                                                                                 gpointer self);
static gboolean _tarot_widget___lambda25_ (TarotWidget* self,
                                    GdkEventMotion* motion,
                                    gsize i_card);
static gboolean __tarot_widget___lambda25__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                              GdkEventMotion* motion,
                                                                              gsize index,
                                                                              gpointer self);
static gboolean _tarot_widget___lambda26_ (TarotWidget* self,
                                    GdkEventMotion* motion);
static gboolean __tarot_widget___lambda26__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                                 GdkEventMotion* motion,
                                                                                 gpointer self);
static gboolean _tarot_widget___lambda27_ (TarotWidget* self,
                                    GdkEventButton* button,
                                    gsize i_card);
static gboolean __tarot_widget___lambda27__tarot_card_view_button_press_event_card (TarotCardView* _sender,
                                                                             GdkEventButton* button,
                                                                             gsize index,
                                                                             gpointer self);
static gboolean _tarot_widget___lambda28_ (TarotWidget* self,
                                    GdkEventButton* button);
static gboolean __tarot_widget___lambda28__tarot_card_view_button_press_event_no_card (TarotCardView* _sender,
                                                                                GdkEventButton* button,
                                                                                gpointer self);
static void _tarot_widget___lambda29_ (TarotWidget* self,
                                gint n);
static void __tarot_widget___lambda29__tarot_card_selection_n_remaining_cards_to_select (TarotCardSelection* _sender,
                                                                                  gint n,
                                                                                  gpointer self);
static void tarot_widget_finalize (GObject * obj);
static void _vala_tarot_widget_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_tarot_widget_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);


static inline gpointer
tarot_widget_get_instance_private (TarotWidget* self)
{
	return G_STRUCT_MEMBER_P (self, TarotWidget_private_offset);
}


static void
_vala_TarotGame_free (TarotGame* self)
{
	g_boxed_free (tarot_game_get_type (), self);
}


static void
tarot_widget_select_pass (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_PASS);
}


static void
_tarot_widget_select_pass_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_pass ((TarotWidget*) self);
}


static void
tarot_widget_select_take (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_TAKE);
}


static void
_tarot_widget_select_take_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_take ((TarotWidget*) self);
}


static void
tarot_widget_select_push (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_PUSH);
}


static void
_tarot_widget_select_push_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_push ((TarotWidget*) self);
}


static void
tarot_widget_select_straight_keep (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_STRAIGHT_KEEP);
}


static void
_tarot_widget_select_straight_keep_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	tarot_widget_select_straight_keep ((TarotWidget*) self);
}


static void
tarot_widget_select_double_keep (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL], 0, TAROT_DOUBLE_KEEP);
}


static void
_tarot_widget_select_double_keep_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
	tarot_widget_select_double_keep ((TarotWidget*) self);
}


static void
tarot_widget_select_none (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_DECLARATION_SIGNAL], 0, FALSE);
}


static void
_tarot_widget_select_none_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_none ((TarotWidget*) self);
}


static void
tarot_widget_select_slam (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_DECLARATION_SIGNAL], 0, TRUE);
}


static void
_tarot_widget_select_slam_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_widget_select_slam ((TarotWidget*) self);
}


static void
tarot_widget_button_call_clicked (TarotWidget* self)
{
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	TarotCard _tmp4_;
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	_tmp0_ = self->priv->call_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = _tmp3_[0];
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_CALL_SIGNAL], 0, (guint) _tmp4_);
	_tmp3_ = (g_free (_tmp3_), NULL);
}


static void
_tarot_widget_button_call_clicked_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
	tarot_widget_button_call_clicked ((TarotWidget*) self);
}


static void
tarot_widget_valid_call_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_call;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
}


static void
_tarot_widget_valid_call_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                         gpointer self)
{
	tarot_widget_valid_call_selection ((TarotWidget*) self);
}


static void
tarot_widget_invalid_call_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_call;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
}


static void
_tarot_widget_invalid_call_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                             gpointer self)
{
	tarot_widget_invalid_call_selection ((TarotWidget*) self);
}


static void
tarot_widget_button_discard_clicked (TarotWidget* self)
{
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	_tmp0_ = self->priv->discard_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_DISCARD_SIGNAL], 0, _tmp3_, _tmp1_);
	_tmp3_ = (g_free (_tmp3_), NULL);
}


static void
_tarot_widget_button_discard_clicked_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	tarot_widget_button_discard_clicked ((TarotWidget*) self);
}


static void
tarot_widget_valid_discard_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_discard;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
}


static void
_tarot_widget_valid_discard_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                            gpointer self)
{
	tarot_widget_valid_discard_selection ((TarotWidget*) self);
}


static void
tarot_widget_invalid_discard_selection (TarotWidget* self)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_discard;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
}


static void
_tarot_widget_invalid_discard_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                gpointer self)
{
	tarot_widget_invalid_discard_selection ((TarotWidget*) self);
}


static void
tarot_widget_button_handful_clicked (TarotWidget* self)
{
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	g_return_if_fail (self != NULL);
	tarot_widget_dont_ask (self);
	_tmp0_ = self->priv->handful_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_HANDFUL_SIGNAL], 0, _tmp3_, _tmp1_);
	_tmp3_ = (g_free (_tmp3_), NULL);
}


static void
_tarot_widget_button_handful_clicked_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	tarot_widget_button_handful_clicked ((TarotWidget*) self);
}


static void
_vala_TarotGameEvent_free (TarotGameEvent* self)
{
	g_boxed_free (tarot_game_event_get_type (), self);
}


static void
tarot_widget_valid_handful_selection (TarotWidget* self)
{
	TarotGameEvent* e = NULL;
	TarotCardSelection* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	TarotGameEvent* _tmp4_;
	TarotGameEvent* _tmp5_;
	GtkButton* _tmp6_;
	TarotGame* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->handful_selection;
	_tmp2_ = tarot_card_selection_get_selection (_tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = tarot_game_event_alloc_handful (_tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	e = _tmp5_;
	_tmp6_ = self->priv->button_handful;
	_tmp7_ = self->priv->current_game;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, tarot_game_check_event (_tmp7_, e));
	__vala_TarotGameEvent_free0 (e);
}


static void
_tarot_widget_valid_handful_selection_tarot_card_selection_valid_selection (TarotCardSelection* _sender,
                                                                            gpointer self)
{
	tarot_widget_valid_handful_selection ((TarotWidget*) self);
}


static void
tarot_widget_invalid_handful_selection (TarotWidget* self)
{
	g_return_if_fail (self != NULL);
	tarot_widget_valid_handful_selection (self);
}


static void
_tarot_widget_invalid_handful_selection_tarot_card_selection_invalid_selection (TarotCardSelection* _sender,
                                                                                gpointer self)
{
	tarot_widget_invalid_handful_selection ((TarotWidget*) self);
}


void
tarot_widget_ask_bid (TarotWidget* self,
                      TarotBid minimum)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkStack* _tmp14_;
	GtkFlowBox* _tmp15_;
	GtkStack* _tmp16_;
	GtkWidget* _tmp17_;
	GtkWidget* _tmp18_;
	GtkFlowBox* _tmp19_;
	GtkStack* _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_double_keep;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
	_tmp1_ = self->priv->button_straight_keep;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
	_tmp2_ = self->priv->button_push;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
	_tmp3_ = self->priv->button_take;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
	switch (minimum) {
		case TAROT_PASS:
		case TAROT_TAKE:
		{
			GtkButton* _tmp4_;
			GtkButton* _tmp5_;
			GtkButton* _tmp6_;
			GtkButton* _tmp7_;
			_tmp4_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
			_tmp5_ = self->priv->button_straight_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
			_tmp6_ = self->priv->button_push;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
			_tmp7_ = self->priv->button_take;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
			break;
		}
		case TAROT_PUSH:
		{
			GtkButton* _tmp8_;
			GtkButton* _tmp9_;
			GtkButton* _tmp10_;
			_tmp8_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
			_tmp9_ = self->priv->button_straight_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, TRUE);
			_tmp10_ = self->priv->button_push;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
			break;
		}
		case TAROT_STRAIGHT_KEEP:
		{
			GtkButton* _tmp11_;
			GtkButton* _tmp12_;
			_tmp11_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, TRUE);
			_tmp12_ = self->priv->button_straight_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, TRUE);
			break;
		}
		case TAROT_DOUBLE_KEEP:
		{
			GtkButton* _tmp13_;
			_tmp13_ = self->priv->button_double_keep;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
			break;
		}
		default:
		break;
	}
	_tmp14_ = self->priv->entry_stack;
	_tmp15_ = self->priv->widget_bid;
	gtk_stack_set_visible_child (_tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = self->priv->entry_stack;
	_tmp17_ = gtk_stack_get_visible_child (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = self->priv->widget_bid;
	_vala_assert (_tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_bid");
	_tmp20_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp20_);
}


void
tarot_widget_ask_declaration (TarotWidget* self,
                              gboolean allowed)
{
	GtkButton* _tmp0_;
	GtkStack* _tmp1_;
	GtkBox* _tmp2_;
	GtkStack* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkBox* _tmp6_;
	GtkStack* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->button_slam;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, allowed);
	_tmp1_ = self->priv->entry_stack;
	_tmp2_ = self->priv->widget_decl;
	gtk_stack_set_visible_child (_tmp1_, (GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->entry_stack;
	_tmp4_ = gtk_stack_get_visible_child (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->widget_decl;
	_vala_assert (_tmp5_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_decl");
	_tmp7_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp7_);
}


static void
_vala_array_add3 (TarotCard* * array,
                  int* length,
                  int* size,
                  TarotCard value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (TarotCard, *array, *size);
	}
	(*array)[(*length)++] = value;
}


void
tarot_widget_ask_call (TarotWidget* self,
                       TarotNumber mini)
{
	TarotSuit* suits = NULL;
	TarotSuit* _tmp0_;
	gint suits_length1;
	gint _suits_size_;
	TarotNumber jack = 0U;
	TarotNumber knight = 0U;
	TarotNumber _tmp1_;
	TarotNumber queen = 0U;
	TarotNumber _tmp2_;
	TarotNumber king = 0U;
	TarotNumber _tmp3_;
	TarotCard* possible = NULL;
	TarotCard* _tmp4_;
	gint possible_length1;
	gint _possible_size_;
	TarotCardSelection* _tmp16_;
	TarotCard* _tmp17_;
	TarotCard* _tmp18_;
	gint _tmp18__length1;
	TarotCardSelection* _tmp19_;
	TarotCard* _tmp20_;
	gint _tmp20__length1;
	TarotCardSelection* _tmp21_;
	GtkStack* _tmp22_;
	GtkBox* _tmp23_;
	GtkStack* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	GtkBox* _tmp27_;
	GtkStack* _tmp28_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (TarotSuit, 4);
	_tmp0_[0] = TAROT_HEARTS;
	_tmp0_[1] = TAROT_CLUBS;
	_tmp0_[2] = TAROT_DIAMONDS;
	_tmp0_[3] = TAROT_SPADES;
	suits = _tmp0_;
	suits_length1 = 4;
	_suits_size_ = suits_length1;
	jack = (TarotNumber) (10 + 1);
	_tmp1_ = jack;
	knight = _tmp1_ + 1;
	_tmp2_ = knight;
	queen = _tmp2_ + 1;
	_tmp3_ = queen;
	king = _tmp3_ + 1;
	_tmp4_ = g_new0 (TarotCard, 0);
	possible = _tmp4_;
	possible_length1 = 0;
	_possible_size_ = possible_length1;
	{
		TarotNumber i = 0U;
		i = mini;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				TarotNumber _tmp7_;
				TarotNumber _tmp8_;
				TarotSuit* _tmp9_;
				gint _tmp9__length1;
				if (!_tmp5_) {
					TarotNumber _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = i;
				_tmp8_ = king;
				if (!(_tmp7_ <= _tmp8_)) {
					break;
				}
				_tmp9_ = suits;
				_tmp9__length1 = suits_length1;
				{
					TarotSuit* s_collection = NULL;
					gint s_collection_length1 = 0;
					gint _s_collection_size_ = 0;
					gint s_it = 0;
					s_collection = _tmp9_;
					s_collection_length1 = _tmp9__length1;
					for (s_it = 0; s_it < _tmp9__length1; s_it = s_it + 1) {
						TarotSuit s = 0;
						s = s_collection[s_it];
						{
							TarotCard added = 0U;
							TarotNumber _tmp10_;
							TarotSuit _tmp11_;
							TarotCard _tmp12_ = 0U;
							gint _tmp13_;
							TarotCard* _tmp14_;
							gint _tmp14__length1;
							TarotCard _tmp15_;
							_tmp10_ = i;
							_tmp11_ = s;
							_tmp13_ = tarot_of (_tmp10_, _tmp11_, &_tmp12_);
							added = _tmp12_;
							if (_tmp13_ != 0) {
								_vala_assert (FALSE, "false");
							}
							_tmp14_ = possible;
							_tmp14__length1 = possible_length1;
							_tmp15_ = added;
							_vala_array_add3 (&possible, &possible_length1, &_possible_size_, _tmp15_);
						}
					}
				}
			}
		}
	}
	_tmp16_ = self->priv->call_selection;
	_tmp17_ = g_new0 (TarotCard, 0);
	_tmp18_ = _tmp17_;
	_tmp18__length1 = 0;
	tarot_card_selection_set_forced (_tmp16_, _tmp18_, 0);
	_tmp18_ = (g_free (_tmp18_), NULL);
	_tmp19_ = self->priv->call_selection;
	_tmp20_ = possible;
	_tmp20__length1 = possible_length1;
	tarot_card_selection_set_optional (_tmp19_, _tmp20_, _tmp20__length1);
	_tmp21_ = self->priv->call_selection;
	tarot_card_selection_set_n_optional (_tmp21_, (gsize) 1);
	_tmp22_ = self->priv->entry_stack;
	_tmp23_ = self->priv->widget_call;
	gtk_stack_set_visible_child (_tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->entry_stack;
	_tmp25_ = gtk_stack_get_visible_child (_tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = self->priv->widget_call;
	_vala_assert (_tmp26_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_call");
	_tmp28_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp28_);
	possible = (g_free (possible), NULL);
	suits = (g_free (suits), NULL);
}


static TarotCard*
_vala_array_dup1 (TarotCard* self,
                  int length)
{
	return g_memdup (self, length * sizeof (TarotCard));
}


static TarotCard*
_vala_array_dup2 (TarotCard* self,
                  int length)
{
	return g_memdup (self, length * sizeof (TarotCard));
}


static TarotCard*
_vala_array_dup3 (TarotCard* self,
                  int length)
{
	return g_memdup (self, length * sizeof (TarotCard));
}


void
tarot_widget_ask_discard (TarotWidget* self,
                          gsize n,
                          TarotCard* prio,
                          int prio_length1,
                          TarotCard* additional,
                          int additional_length1)
{
	TarotCard* forced = NULL;
	TarotCard* _tmp0_;
	gint forced_length1;
	gint _forced_size_;
	TarotCard* optional = NULL;
	TarotCard* _tmp1_;
	gint _tmp1__length1;
	gint optional_length1;
	gint _optional_size_;
	gsize n_optional = 0UL;
	TarotCardSelection* _tmp4_;
	TarotCard* _tmp5_;
	gint _tmp5__length1;
	TarotCardSelection* _tmp6_;
	TarotCard* _tmp7_;
	gint _tmp7__length1;
	TarotCardSelection* _tmp8_;
	gsize _tmp9_;
	GtkStack* _tmp10_;
	GtkBox* _tmp11_;
	GtkStack* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* _tmp14_;
	GtkBox* _tmp15_;
	GtkStack* _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (TarotCard, 0);
	forced = _tmp0_;
	forced_length1 = 0;
	_forced_size_ = forced_length1;
	_tmp1_ = (prio != NULL) ? _vala_array_dup1 (prio, prio_length1) : ((gpointer) prio);
	_tmp1__length1 = prio_length1;
	optional = _tmp1_;
	optional_length1 = _tmp1__length1;
	_optional_size_ = optional_length1;
	n_optional = n;
	if (n >= ((gsize) prio_length1)) {
		TarotCard* _tmp2_;
		gint _tmp2__length1;
		TarotCard* _tmp3_;
		gint _tmp3__length1;
		_tmp2_ = (prio != NULL) ? _vala_array_dup2 (prio, prio_length1) : ((gpointer) prio);
		_tmp2__length1 = prio_length1;
		forced = (g_free (forced), NULL);
		forced = _tmp2_;
		forced_length1 = _tmp2__length1;
		_forced_size_ = forced_length1;
		_tmp3_ = (additional != NULL) ? _vala_array_dup3 (additional, additional_length1) : ((gpointer) additional);
		_tmp3__length1 = additional_length1;
		optional = (g_free (optional), NULL);
		optional = _tmp3_;
		optional_length1 = _tmp3__length1;
		_optional_size_ = optional_length1;
		n_optional = n - prio_length1;
	}
	_tmp4_ = self->priv->discard_selection;
	_tmp5_ = forced;
	_tmp5__length1 = forced_length1;
	tarot_card_selection_set_forced (_tmp4_, _tmp5_, _tmp5__length1);
	_tmp6_ = self->priv->discard_selection;
	_tmp7_ = optional;
	_tmp7__length1 = optional_length1;
	tarot_card_selection_set_optional (_tmp6_, _tmp7_, _tmp7__length1);
	_tmp8_ = self->priv->discard_selection;
	_tmp9_ = n_optional;
	tarot_card_selection_set_n_optional (_tmp8_, _tmp9_);
	_tmp10_ = self->priv->entry_stack;
	_tmp11_ = self->priv->widget_discard;
	gtk_stack_set_visible_child (_tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->entry_stack;
	_tmp13_ = gtk_stack_get_visible_child (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->widget_discard;
	_vala_assert (_tmp14_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_discard");
	_tmp16_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp16_);
	optional = (g_free (optional), NULL);
	forced = (g_free (forced), NULL);
}


static TarotCard*
_vala_array_dup4 (TarotCard* self,
                  int length)
{
	return g_memdup (self, length * sizeof (TarotCard));
}


static void
_vala_array_add4 (TarotCard* * array,
                  int* length,
                  int* size,
                  TarotCard value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (TarotCard, *array, *size);
	}
	(*array)[(*length)++] = value;
}


void
tarot_widget_ask_handful (TarotWidget* self,
                          gsize n_simple,
                          gsize n_double,
                          gsize n_triple,
                          TarotCard* prio,
                          int prio_length1,
                          TarotCard* additional,
                          int additional_length1)
{
	TarotCard* forced = NULL;
	TarotCard* _tmp0_;
	gint forced_length1;
	gint _forced_size_;
	TarotCard* optional = NULL;
	TarotCard* _tmp1_;
	gint _tmp1__length1;
	gint optional_length1;
	gint _optional_size_;
	gsize n_optional = 0UL;
	TarotCardSelection* _tmp4_;
	TarotCard* _tmp5_;
	gint _tmp5__length1;
	TarotCardSelection* _tmp6_;
	TarotCard* _tmp7_;
	gint _tmp7__length1;
	TarotCardSelection* _tmp8_;
	GtkStack* _tmp9_;
	GtkBox* _tmp10_;
	GtkStack* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkBox* _tmp14_;
	GtkStack* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (TarotCard, 0);
	forced = _tmp0_;
	forced_length1 = 0;
	_forced_size_ = forced_length1;
	_tmp1_ = (prio != NULL) ? _vala_array_dup4 (prio, prio_length1) : ((gpointer) prio);
	_tmp1__length1 = prio_length1;
	optional = _tmp1_;
	optional_length1 = _tmp1__length1;
	_optional_size_ = optional_length1;
	{
		TarotCard* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
		c_collection = additional;
		c_collection_length1 = additional_length1;
		for (c_it = 0; c_it < additional_length1; c_it = c_it + 1) {
			TarotCard c = 0U;
			c = c_collection[c_it];
			{
				TarotCard* _tmp2_;
				gint _tmp2__length1;
				TarotCard _tmp3_;
				_tmp2_ = optional;
				_tmp2__length1 = optional_length1;
				_tmp3_ = c;
				_vala_array_add4 (&optional, &optional_length1, &_optional_size_, _tmp3_);
			}
		}
	}
	n_optional = n_simple;
	_tmp4_ = self->priv->handful_selection;
	_tmp5_ = forced;
	_tmp5__length1 = forced_length1;
	tarot_card_selection_set_forced (_tmp4_, _tmp5_, _tmp5__length1);
	_tmp6_ = self->priv->handful_selection;
	_tmp7_ = optional;
	_tmp7__length1 = optional_length1;
	tarot_card_selection_set_optional (_tmp6_, _tmp7_, _tmp7__length1);
	_tmp8_ = self->priv->handful_selection;
	tarot_card_selection_set_n_optional (_tmp8_, n_optional);
	_tmp9_ = self->priv->entry_stack;
	_tmp10_ = self->priv->widget_handful;
	gtk_stack_set_visible_child (_tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->entry_stack;
	_tmp12_ = gtk_stack_get_visible_child (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = self->priv->widget_handful;
	_vala_assert (_tmp13_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget), "entry_stack.visible_child == widget_handful");
	_tmp15_ = self->priv->entry_stack;
	gtk_widget_show ((GtkWidget*) _tmp15_);
	optional = (g_free (optional), NULL);
	forced = (g_free (forced), NULL);
}


static void
_vala_array_add5 (gsize* * array,
                  int* length,
                  int* size,
                  gsize value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gsize, *array, *size);
	}
	(*array)[(*length)++] = value;
}


void
tarot_widget_ask_play (TarotWidget* self,
                       TarotCard* playable,
                       int playable_length1)
{
	gboolean* is_playable = NULL;
	gboolean* _tmp0_;
	gint is_playable_length1;
	gint _is_playable_size_;
	gsize* i = NULL;
	gsize* _tmp8_;
	gint i_length1;
	gint _i_size_;
	TarotCard* all_cards = NULL;
	TarotFanCardView* _tmp9_;
	gint _tmp10_ = 0;
	TarotCard* _tmp11_;
	gint all_cards_length1;
	gint _all_cards_size_;
	TarotFanCardView* _tmp23_;
	gsize* _tmp24_;
	gint _tmp24__length1;
	g_return_if_fail (self != NULL);
	self->priv->allow_play = TRUE;
	_tmp0_ = g_new0 (gboolean, 78);
	is_playable = _tmp0_;
	is_playable_length1 = 78;
	_is_playable_size_ = is_playable_length1;
	{
		gsize i = 0UL;
		i = (gsize) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gsize _tmp3_;
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gsize _tmp5_;
				if (!_tmp1_) {
					gsize _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				if (!(_tmp3_ < ((gsize) 78))) {
					break;
				}
				_tmp4_ = is_playable;
				_tmp4__length1 = is_playable_length1;
				_tmp5_ = i;
				_tmp4_[_tmp5_] = FALSE;
			}
		}
	}
	{
		TarotCard* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
		c_collection = playable;
		c_collection_length1 = playable_length1;
		for (c_it = 0; c_it < playable_length1; c_it = c_it + 1) {
			TarotCard c = 0U;
			c = c_collection[c_it];
			{
				gboolean* _tmp6_;
				gint _tmp6__length1;
				TarotCard _tmp7_;
				_tmp6_ = is_playable;
				_tmp6__length1 = is_playable_length1;
				_tmp7_ = c;
				_tmp6_[(gint) _tmp7_] = TRUE;
			}
		}
	}
	_tmp8_ = g_new0 (gsize, 0);
	i = _tmp8_;
	i_length1 = 0;
	_i_size_ = i_length1;
	_tmp9_ = self->priv->hand_widget;
	_tmp11_ = tarot_card_view_get_cards ((TarotCardView*) _tmp9_, &_tmp10_);
	all_cards = _tmp11_;
	all_cards_length1 = _tmp10_;
	_all_cards_size_ = all_cards_length1;
	{
		gsize j = 0UL;
		j = (gsize) 0;
		{
			gboolean _tmp12_ = FALSE;
			_tmp12_ = TRUE;
			while (TRUE) {
				gsize _tmp14_;
				TarotCard* _tmp15_;
				gint _tmp15__length1;
				gboolean* _tmp16_;
				gint _tmp16__length1;
				TarotCard* _tmp17_;
				gint _tmp17__length1;
				gsize _tmp18_;
				TarotCard _tmp19_;
				gboolean _tmp20_;
				if (!_tmp12_) {
					gsize _tmp13_;
					_tmp13_ = j;
					j = _tmp13_ + 1;
				}
				_tmp12_ = FALSE;
				_tmp14_ = j;
				_tmp15_ = all_cards;
				_tmp15__length1 = all_cards_length1;
				if (!(_tmp14_ < ((gsize) _tmp15__length1))) {
					break;
				}
				_tmp16_ = is_playable;
				_tmp16__length1 = is_playable_length1;
				_tmp17_ = all_cards;
				_tmp17__length1 = all_cards_length1;
				_tmp18_ = j;
				_tmp19_ = _tmp17_[_tmp18_];
				_tmp20_ = _tmp16_[_tmp19_];
				if (_tmp20_) {
					gsize* _tmp21_;
					gint _tmp21__length1;
					gsize _tmp22_;
					_tmp21_ = i;
					_tmp21__length1 = i_length1;
					_tmp22_ = j;
					_vala_array_add5 (&i, &i_length1, &_i_size_, _tmp22_);
				}
			}
		}
	}
	_tmp23_ = self->priv->hand_widget;
	_tmp24_ = i;
	_tmp24__length1 = i_length1;
	tarot_card_view_set_selectable ((TarotCardView*) _tmp23_, _tmp24_, _tmp24__length1);
	all_cards = (g_free (all_cards), NULL);
	i = (g_free (i), NULL);
	is_playable = (g_free (is_playable), NULL);
}


void
tarot_widget_dont_ask (TarotWidget* self)
{
	GtkStack* _tmp0_;
	gsize* empty_selectable = NULL;
	gsize* _tmp1_;
	gint empty_selectable_length1;
	gint _empty_selectable_size_;
	TarotFanCardView* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->entry_stack;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	self->priv->allow_play = FALSE;
	_tmp1_ = g_new0 (gsize, 0);
	empty_selectable = _tmp1_;
	empty_selectable_length1 = 0;
	_empty_selectable_size_ = empty_selectable_length1;
	_tmp2_ = self->priv->hand_widget;
	tarot_card_view_set_selectable ((TarotCardView*) _tmp2_, empty_selectable, empty_selectable_length1);
	empty_selectable = (g_free (empty_selectable), NULL);
}


static gchar*
tarot_widget_compute_my_status_with_score (TarotWidget* self)
{
	gchar* result = NULL;
	TarotPlayer myself = 0U;
	TarotGame* _tmp0_;
	TarotPlayer _tmp1_ = 0U;
	TarotGameError _tmp2_;
	gint* scores = NULL;
	gint scores_length1 = 0;
	gint _scores_size_ = 0;
	TarotGame* _tmp3_;
	gint* _tmp4_ = NULL;
	gsize _tmp5_;
	TarotGameError _tmp6_;
	TarotPlayer _tmp15_;
	gchar* _tmp16_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->current_game;
	_tmp2_ = tarot_game_get_main_player (_tmp0_, &_tmp1_);
	myself = _tmp1_;
	if (_tmp2_ != TAROT_GAME_OK) {
		myself = (TarotPlayer) 0;
	}
	_tmp3_ = self->priv->current_game;
	_tmp6_ = tarot_game_get_scores_alloc (_tmp3_, &_tmp5_, &_tmp4_);
	scores = (g_free (scores), NULL);
	scores = _tmp4_;
	scores_length1 = _tmp5_;
	_scores_size_ = scores_length1;
	if (_tmp6_ == TAROT_GAME_OK) {
		TarotPlayer _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gint* _tmp10_;
		gint _tmp10__length1;
		TarotPlayer _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp7_ = myself;
		_tmp8_ = tarot_widget_compute_my_status (self, _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = scores;
		_tmp10__length1 = scores_length1;
		_tmp11_ = myself;
		_tmp12_ = _tmp10_[_tmp11_];
		_tmp13_ = g_strdup_printf (_ ("%s\nScore: %d"), _tmp9_, _tmp12_);
		_tmp14_ = _tmp13_;
		_g_free0 (_tmp9_);
		result = _tmp14_;
		scores = (g_free (scores), NULL);
		return result;
	}
	_tmp15_ = myself;
	_tmp16_ = tarot_widget_compute_my_status (self, _tmp15_);
	result = _tmp16_;
	scores = (g_free (scores), NULL);
	return result;
}


static gchar*
tarot_widget_compute_my_status (TarotWidget* self,
                                TarotPlayer myself)
{
	gchar* result = NULL;
	TarotPlayer taker = 0U;
	TarotGame* _tmp0_;
	TarotPlayer _tmp1_ = 0U;
	TarotBid* bids = NULL;
	gint bids_length1 = 0;
	gint _bids_size_ = 0;
	TarotPlayer partner = 0U;
	gboolean _tmp2_ = FALSE;
	TarotGame* _tmp3_;
	TarotBid* _tmp4_ = NULL;
	gsize _tmp5_;
	TarotGameError _tmp6_;
	gchar* _tmp123_;
	gchar* _tmp124_;
	gchar* _tmp125_;
	gchar* _tmp126_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->current_game;
	tarot_game_get_taker (_tmp0_, &_tmp1_);
	taker = _tmp1_;
	_tmp3_ = self->priv->current_game;
	_tmp6_ = tarot_game_get_bids_alloc (_tmp3_, &_tmp5_, &_tmp4_);
	bids = (g_free (bids), NULL);
	bids = _tmp4_;
	bids_length1 = _tmp5_;
	_bids_size_ = bids_length1;
	if (_tmp6_ == TAROT_GAME_OK) {
		TarotBid* _tmp7_;
		gint _tmp7__length1;
		_tmp7_ = bids;
		_tmp7__length1 = bids_length1;
		_tmp2_ = ((TarotPlayer) _tmp7__length1) > myself;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		TarotPlayer _tmp8_;
		_tmp8_ = taker;
		if (_tmp8_ == myself) {
			TarotPlayer declarant = 0U;
			gboolean _tmp9_ = FALSE;
			TarotGame* _tmp10_;
			TarotPlayer _tmp11_ = 0U;
			TarotGameError _tmp12_;
			_tmp10_ = self->priv->current_game;
			_tmp12_ = tarot_game_get_declarant (_tmp10_, &_tmp11_);
			declarant = _tmp11_;
			if (_tmp12_ == TAROT_GAME_OK) {
				TarotPlayer _tmp13_;
				_tmp13_ = declarant;
				_tmp9_ = _tmp13_ == myself;
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				TarotBid* _tmp14_;
				gint _tmp14__length1;
				TarotPlayer _tmp15_;
				TarotBid _tmp16_;
				_tmp14_ = bids;
				_tmp14__length1 = bids_length1;
				_tmp15_ = taker;
				_tmp16_ = _tmp14_[_tmp15_];
				switch (_tmp16_) {
					case TAROT_PASS:
					{
						gchar* _tmp17_;
						gchar* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
						_tmp17_ = tarot_player_to_string_alloc (myself);
						_tmp18_ = _tmp17_;
						_tmp19_ = g_strdup_printf (_ ("%s slams!"), _tmp18_);
						_tmp20_ = _tmp19_;
						_g_free0 (_tmp18_);
						result = _tmp20_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_TAKE:
					{
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						_tmp21_ = tarot_player_to_string_alloc (myself);
						_tmp22_ = _tmp21_;
						_tmp23_ = g_strdup_printf (_ ("%s takes with slam!"), _tmp22_);
						_tmp24_ = _tmp23_;
						_g_free0 (_tmp22_);
						result = _tmp24_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_PUSH:
					{
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						_tmp25_ = tarot_player_to_string_alloc (myself);
						_tmp26_ = _tmp25_;
						_tmp27_ = g_strdup_printf (_ ("%s pushes with slam!"), _tmp26_);
						_tmp28_ = _tmp27_;
						_g_free0 (_tmp26_);
						result = _tmp28_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_STRAIGHT_KEEP:
					{
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
						_tmp29_ = tarot_player_to_string_alloc (myself);
						_tmp30_ = _tmp29_;
						_tmp31_ = g_strdup_printf (_ ("%s keeps with slam!"), _tmp30_);
						_tmp32_ = _tmp31_;
						_g_free0 (_tmp30_);
						result = _tmp32_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_DOUBLE_KEEP:
					{
						gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						_tmp33_ = tarot_player_to_string_alloc (myself);
						_tmp34_ = _tmp33_;
						_tmp35_ = g_strdup_printf (_ ("%s keeps (double, with slam)!"), _tmp34_);
						_tmp36_ = _tmp35_;
						_g_free0 (_tmp34_);
						result = _tmp36_;
						bids = (g_free (bids), NULL);
						return result;
					}
					default:
					break;
				}
			} else {
				TarotBid* _tmp37_;
				gint _tmp37__length1;
				TarotPlayer _tmp38_;
				TarotBid _tmp39_;
				_tmp37_ = bids;
				_tmp37__length1 = bids_length1;
				_tmp38_ = taker;
				_tmp39_ = _tmp37_[_tmp38_];
				switch (_tmp39_) {
					case TAROT_PASS:
					{
						gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						_tmp40_ = tarot_player_to_string_alloc (myself);
						_tmp41_ = _tmp40_;
						_tmp42_ = g_strdup_printf (_ ("%s (pass)"), _tmp41_);
						_tmp43_ = _tmp42_;
						_g_free0 (_tmp41_);
						result = _tmp43_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_TAKE:
					{
						gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						_tmp44_ = tarot_player_to_string_alloc (myself);
						_tmp45_ = _tmp44_;
						_tmp46_ = g_strdup_printf (_ ("%s takes."), _tmp45_);
						_tmp47_ = _tmp46_;
						_g_free0 (_tmp45_);
						result = _tmp47_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_PUSH:
					{
						gchar* _tmp48_;
						gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						_tmp48_ = tarot_player_to_string_alloc (myself);
						_tmp49_ = _tmp48_;
						_tmp50_ = g_strdup_printf (_ ("%s pushes."), _tmp49_);
						_tmp51_ = _tmp50_;
						_g_free0 (_tmp49_);
						result = _tmp51_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_STRAIGHT_KEEP:
					{
						gchar* _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						_tmp52_ = tarot_player_to_string_alloc (myself);
						_tmp53_ = _tmp52_;
						_tmp54_ = g_strdup_printf (_ ("%s keeps."), _tmp53_);
						_tmp55_ = _tmp54_;
						_g_free0 (_tmp53_);
						result = _tmp55_;
						bids = (g_free (bids), NULL);
						return result;
					}
					case TAROT_DOUBLE_KEEP:
					{
						gchar* _tmp56_;
						gchar* _tmp57_;
						gchar* _tmp58_;
						gchar* _tmp59_;
						_tmp56_ = tarot_player_to_string_alloc (myself);
						_tmp57_ = _tmp56_;
						_tmp58_ = g_strdup_printf (_ ("%s keeps (double)."), _tmp57_);
						_tmp59_ = _tmp58_;
						_g_free0 (_tmp57_);
						result = _tmp59_;
						bids = (g_free (bids), NULL);
						return result;
					}
					default:
					break;
				}
			}
		} else {
			gboolean _tmp60_ = FALSE;
			TarotGame* _tmp61_;
			TarotPlayer _tmp62_ = 0U;
			TarotGameError _tmp63_;
			_tmp61_ = self->priv->current_game;
			_tmp63_ = tarot_game_get_partner (_tmp61_, &_tmp62_);
			partner = _tmp62_;
			if (_tmp63_ == TAROT_GAME_OK) {
				TarotPlayer _tmp64_;
				_tmp64_ = partner;
				_tmp60_ = _tmp64_ == myself;
			} else {
				_tmp60_ = FALSE;
			}
			if (_tmp60_) {
				TarotPlayer declarant = 0U;
				gboolean _tmp65_ = FALSE;
				TarotGame* _tmp66_;
				TarotPlayer _tmp67_ = 0U;
				TarotGameError _tmp68_;
				_tmp66_ = self->priv->current_game;
				_tmp68_ = tarot_game_get_declarant (_tmp66_, &_tmp67_);
				declarant = _tmp67_;
				if (_tmp68_ == TAROT_GAME_OK) {
					TarotPlayer _tmp69_;
					_tmp69_ = declarant;
					_tmp65_ = _tmp69_ == myself;
				} else {
					_tmp65_ = FALSE;
				}
				if (_tmp65_) {
					gchar* _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
					_tmp70_ = tarot_player_to_string_alloc (myself);
					_tmp71_ = _tmp70_;
					_tmp72_ = g_strdup_printf (_ ("%s (called) slams!"), _tmp71_);
					_tmp73_ = _tmp72_;
					_g_free0 (_tmp71_);
					result = _tmp73_;
					bids = (g_free (bids), NULL);
					return result;
				} else {
					gchar* _tmp74_;
					gchar* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
					_tmp74_ = tarot_player_to_string_alloc (myself);
					_tmp75_ = _tmp74_;
					_tmp76_ = g_strdup_printf (_ ("%s (called)"), _tmp75_);
					_tmp77_ = _tmp76_;
					_g_free0 (_tmp75_);
					result = _tmp77_;
					bids = (g_free (bids), NULL);
					return result;
				}
			} else {
				TarotPlayer declarant = 0U;
				gboolean _tmp78_ = FALSE;
				TarotGame* _tmp79_;
				TarotPlayer _tmp80_ = 0U;
				TarotGameError _tmp81_;
				_tmp79_ = self->priv->current_game;
				_tmp81_ = tarot_game_get_declarant (_tmp79_, &_tmp80_);
				declarant = _tmp80_;
				if (_tmp81_ == TAROT_GAME_OK) {
					TarotPlayer _tmp82_;
					_tmp82_ = declarant;
					_tmp78_ = _tmp82_ == myself;
				} else {
					_tmp78_ = FALSE;
				}
				if (_tmp78_) {
					TarotBid* _tmp83_;
					gint _tmp83__length1;
					TarotBid _tmp84_;
					_tmp83_ = bids;
					_tmp83__length1 = bids_length1;
					_tmp84_ = _tmp83_[myself];
					switch (_tmp84_) {
						case TAROT_PASS:
						{
							gchar* _tmp85_;
							gchar* _tmp86_;
							gchar* _tmp87_;
							gchar* _tmp88_;
							_tmp85_ = tarot_player_to_string_alloc (myself);
							_tmp86_ = _tmp85_;
							_tmp87_ = g_strdup_printf (_ ("%s slams!"), _tmp86_);
							_tmp88_ = _tmp87_;
							_g_free0 (_tmp86_);
							result = _tmp88_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_TAKE:
						{
							gchar* _tmp89_;
							gchar* _tmp90_;
							gchar* _tmp91_;
							gchar* _tmp92_;
							_tmp89_ = tarot_player_to_string_alloc (myself);
							_tmp90_ = _tmp89_;
							_tmp91_ = g_strdup_printf (_ ("%s slams (take)!"), _tmp90_);
							_tmp92_ = _tmp91_;
							_g_free0 (_tmp90_);
							result = _tmp92_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_PUSH:
						{
							gchar* _tmp93_;
							gchar* _tmp94_;
							gchar* _tmp95_;
							gchar* _tmp96_;
							_tmp93_ = tarot_player_to_string_alloc (myself);
							_tmp94_ = _tmp93_;
							_tmp95_ = g_strdup_printf (_ ("%s slams (push)!"), _tmp94_);
							_tmp96_ = _tmp95_;
							_g_free0 (_tmp94_);
							result = _tmp96_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_STRAIGHT_KEEP:
						{
							gchar* _tmp97_;
							gchar* _tmp98_;
							gchar* _tmp99_;
							gchar* _tmp100_;
							_tmp97_ = tarot_player_to_string_alloc (myself);
							_tmp98_ = _tmp97_;
							_tmp99_ = g_strdup_printf (_ ("%s slams (str. keep)!"), _tmp98_);
							_tmp100_ = _tmp99_;
							_g_free0 (_tmp98_);
							result = _tmp100_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_DOUBLE_KEEP:
						{
							gchar* _tmp101_;
							gchar* _tmp102_;
							gchar* _tmp103_;
							gchar* _tmp104_;
							_tmp101_ = tarot_player_to_string_alloc (myself);
							_tmp102_ = _tmp101_;
							_tmp103_ = g_strdup_printf (_ ("%s slams (dbl. keep)!"), _tmp102_);
							_tmp104_ = _tmp103_;
							_g_free0 (_tmp102_);
							result = _tmp104_;
							bids = (g_free (bids), NULL);
							return result;
						}
						default:
						break;
					}
				} else {
					TarotBid* _tmp105_;
					gint _tmp105__length1;
					TarotBid _tmp106_;
					_tmp105_ = bids;
					_tmp105__length1 = bids_length1;
					_tmp106_ = _tmp105_[myself];
					switch (_tmp106_) {
						case TAROT_TAKE:
						{
							gchar* _tmp107_;
							gchar* _tmp108_;
							gchar* _tmp109_;
							gchar* _tmp110_;
							_tmp107_ = tarot_player_to_string_alloc (myself);
							_tmp108_ = _tmp107_;
							_tmp109_ = g_strdup_printf (_ ("%s (take)"), _tmp108_);
							_tmp110_ = _tmp109_;
							_g_free0 (_tmp108_);
							result = _tmp110_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_PUSH:
						{
							gchar* _tmp111_;
							gchar* _tmp112_;
							gchar* _tmp113_;
							gchar* _tmp114_;
							_tmp111_ = tarot_player_to_string_alloc (myself);
							_tmp112_ = _tmp111_;
							_tmp113_ = g_strdup_printf (_ ("%s (push)"), _tmp112_);
							_tmp114_ = _tmp113_;
							_g_free0 (_tmp112_);
							result = _tmp114_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_STRAIGHT_KEEP:
						{
							gchar* _tmp115_;
							gchar* _tmp116_;
							gchar* _tmp117_;
							gchar* _tmp118_;
							_tmp115_ = tarot_player_to_string_alloc (myself);
							_tmp116_ = _tmp115_;
							_tmp117_ = g_strdup_printf (_ ("%s (str. keep)"), _tmp116_);
							_tmp118_ = _tmp117_;
							_g_free0 (_tmp116_);
							result = _tmp118_;
							bids = (g_free (bids), NULL);
							return result;
						}
						case TAROT_DOUBLE_KEEP:
						{
							gchar* _tmp119_;
							gchar* _tmp120_;
							gchar* _tmp121_;
							gchar* _tmp122_;
							_tmp119_ = tarot_player_to_string_alloc (myself);
							_tmp120_ = _tmp119_;
							_tmp121_ = g_strdup_printf (_ ("%s (dbl. keep)"), _tmp120_);
							_tmp122_ = _tmp121_;
							_g_free0 (_tmp120_);
							result = _tmp122_;
							bids = (g_free (bids), NULL);
							return result;
						}
						default:
						break;
					}
				}
			}
		}
	}
	_tmp123_ = tarot_player_to_string_alloc (myself);
	_tmp124_ = _tmp123_;
	_tmp125_ = g_strdup_printf (_ ("%s"), _tmp124_);
	_tmp126_ = _tmp125_;
	_g_free0 (_tmp124_);
	result = _tmp126_;
	bids = (g_free (bids), NULL);
	return result;
}


static void
tarot_widget_update_header_model (TarotWidget* self)
{
	gsize n_players = 0UL;
	TarotGame* _tmp0_;
	GType* types = NULL;
	gsize _tmp1_;
	GType* _tmp2_;
	gint types_length1;
	gint _types_size_;
	GtkListStore* model = NULL;
	GType* _tmp9_;
	gint _tmp9__length1;
	GtkListStore* _tmp10_;
	GtkTreeIter iter = {0};
	TarotPlayer myself = 0U;
	TarotGame* _tmp11_;
	TarotPlayer _tmp12_ = 0U;
	TarotGameError _tmp13_;
	TarotBid* bids = NULL;
	gint bids_length1 = 0;
	gint _bids_size_ = 0;
	TarotGame* _tmp14_;
	TarotBid* _tmp15_ = NULL;
	gsize _tmp16_;
	TarotGameError _tmp17_;
	TarotPlayer declarant = 0U;
	gboolean _tmp49_ = FALSE;
	TarotGame* _tmp50_;
	TarotPlayer _tmp51_ = 0U;
	TarotGameError _tmp52_;
	gint* scores = NULL;
	gint scores_length1 = 0;
	gint _scores_size_ = 0;
	TarotGame* _tmp69_;
	gint* _tmp70_ = NULL;
	gsize _tmp71_;
	TarotGameError _tmp72_;
	GtkTreeView* _tmp90_;
	GtkListStore* _tmp91_;
	GList* columns = NULL;
	GtkTreeView* _tmp92_;
	GList* _tmp93_;
	GList* _tmp94_;
	TarotPlayer taker = 0U;
	TarotGame* _tmp97_;
	TarotPlayer _tmp98_ = 0U;
	TarotPlayer partner = 0U;
	gboolean has_partner = FALSE;
	TarotGame* _tmp99_;
	TarotPlayer _tmp100_ = 0U;
	TarotGameError _tmp101_;
	GtkTreeView* _tmp132_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_game;
	n_players = tarot_game_n_players (_tmp0_);
	_tmp1_ = n_players;
	_tmp2_ = g_new0 (GType, _tmp1_ - 1);
	types = _tmp2_;
	types_length1 = _tmp1_ - 1;
	_types_size_ = types_length1;
	{
		gsize i = 0UL;
		i = (gsize) 1;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gsize _tmp5_;
				gsize _tmp6_;
				GType* _tmp7_;
				gint _tmp7__length1;
				gsize _tmp8_;
				if (!_tmp3_) {
					gsize _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				_tmp6_ = n_players;
				if (!(_tmp5_ < _tmp6_)) {
					break;
				}
				_tmp7_ = types;
				_tmp7__length1 = types_length1;
				_tmp8_ = i;
				_tmp7_[_tmp8_ - 1] = G_TYPE_STRING;
			}
		}
	}
	_tmp9_ = types;
	_tmp9__length1 = types_length1;
	_tmp10_ = gtk_list_store_newv (_tmp9__length1, _tmp9_);
	model = _tmp10_;
	_tmp11_ = self->priv->current_game;
	_tmp13_ = tarot_game_get_main_player (_tmp11_, &_tmp12_);
	myself = _tmp12_;
	if (_tmp13_ != TAROT_GAME_OK) {
		myself = (TarotPlayer) 0;
	}
	_tmp14_ = self->priv->current_game;
	_tmp17_ = tarot_game_get_bids_alloc (_tmp14_, &_tmp16_, &_tmp15_);
	bids = (g_free (bids), NULL);
	bids = _tmp15_;
	bids_length1 = _tmp16_;
	_bids_size_ = bids_length1;
	if (_tmp17_ == TAROT_GAME_OK) {
		GtkListStore* _tmp18_;
		GtkTreeIter _tmp19_ = {0};
		_tmp18_ = model;
		gtk_list_store_append (_tmp18_, &_tmp19_);
		iter = _tmp19_;
		{
			gsize i = 0UL;
			i = (gsize) 1;
			{
				gboolean _tmp20_ = FALSE;
				_tmp20_ = TRUE;
				while (TRUE) {
					gsize _tmp22_;
					gsize _tmp23_;
					TarotPlayer p = 0U;
					TarotPlayer _tmp24_;
					gsize _tmp25_;
					gsize _tmp26_;
					TarotPlayer _tmp27_;
					TarotBid* _tmp28_;
					gint _tmp28__length1;
					if (!_tmp20_) {
						gsize _tmp21_;
						_tmp21_ = i;
						i = _tmp21_ + 1;
					}
					_tmp20_ = FALSE;
					_tmp22_ = i;
					_tmp23_ = n_players;
					if (!(_tmp22_ < _tmp23_)) {
						break;
					}
					_tmp24_ = myself;
					_tmp25_ = i;
					_tmp26_ = n_players;
					p = (TarotPlayer) ((_tmp24_ + _tmp25_) % _tmp26_);
					_tmp27_ = p;
					_tmp28_ = bids;
					_tmp28__length1 = bids_length1;
					if (_tmp27_ < ((TarotPlayer) _tmp28__length1)) {
						TarotBid* _tmp29_;
						gint _tmp29__length1;
						TarotPlayer _tmp30_;
						TarotBid _tmp31_;
						_tmp29_ = bids;
						_tmp29__length1 = bids_length1;
						_tmp30_ = p;
						_tmp31_ = _tmp29_[_tmp30_];
						switch (_tmp31_) {
							case TAROT_PASS:
							{
								TarotBid* _tmp32_;
								gint _tmp32__length1;
								gsize _tmp33_;
								_tmp32_ = bids;
								_tmp32__length1 = bids_length1;
								_tmp33_ = n_players;
								if (((gsize) _tmp32__length1) < _tmp33_) {
									GtkListStore* _tmp34_;
									GtkTreeIter _tmp35_;
									gsize _tmp36_;
									_tmp34_ = model;
									_tmp35_ = iter;
									_tmp36_ = i;
									gtk_list_store_set (_tmp34_, &_tmp35_, _tmp36_ - 1, _ ("pass"), -1);
								}
								break;
							}
							case TAROT_TAKE:
							{
								GtkListStore* _tmp37_;
								GtkTreeIter _tmp38_;
								gsize _tmp39_;
								_tmp37_ = model;
								_tmp38_ = iter;
								_tmp39_ = i;
								gtk_list_store_set (_tmp37_, &_tmp38_, _tmp39_ - 1, _ ("take"), -1);
								break;
							}
							case TAROT_PUSH:
							{
								GtkListStore* _tmp40_;
								GtkTreeIter _tmp41_;
								gsize _tmp42_;
								_tmp40_ = model;
								_tmp41_ = iter;
								_tmp42_ = i;
								gtk_list_store_set (_tmp40_, &_tmp41_, _tmp42_ - 1, _ ("push"), -1);
								break;
							}
							case TAROT_STRAIGHT_KEEP:
							{
								GtkListStore* _tmp43_;
								GtkTreeIter _tmp44_;
								gsize _tmp45_;
								_tmp43_ = model;
								_tmp44_ = iter;
								_tmp45_ = i;
								gtk_list_store_set (_tmp43_, &_tmp44_, _tmp45_ - 1, _ ("straight keep"), -1);
								break;
							}
							case TAROT_DOUBLE_KEEP:
							{
								GtkListStore* _tmp46_;
								GtkTreeIter _tmp47_;
								gsize _tmp48_;
								_tmp46_ = model;
								_tmp47_ = iter;
								_tmp48_ = i;
								gtk_list_store_set (_tmp46_, &_tmp47_, _tmp48_ - 1, _ ("double keep"), -1);
								break;
							}
							default:
							break;
						}
					}
				}
			}
		}
	}
	_tmp50_ = self->priv->current_game;
	_tmp52_ = tarot_game_get_declarant (_tmp50_, &_tmp51_);
	declarant = _tmp51_;
	if (_tmp52_ == TAROT_GAME_OK) {
		TarotPlayer _tmp53_;
		TarotPlayer _tmp54_;
		_tmp53_ = declarant;
		_tmp54_ = myself;
		_tmp49_ = _tmp53_ != _tmp54_;
	} else {
		_tmp49_ = FALSE;
	}
	if (_tmp49_) {
		GtkListStore* _tmp55_;
		GtkTreeIter _tmp56_ = {0};
		_tmp55_ = model;
		gtk_list_store_append (_tmp55_, &_tmp56_);
		iter = _tmp56_;
		{
			gsize i = 0UL;
			i = (gsize) 1;
			{
				gboolean _tmp57_ = FALSE;
				_tmp57_ = TRUE;
				while (TRUE) {
					gsize _tmp59_;
					gsize _tmp60_;
					TarotPlayer p = 0U;
					TarotPlayer _tmp61_;
					gsize _tmp62_;
					gsize _tmp63_;
					TarotPlayer _tmp64_;
					TarotPlayer _tmp65_;
					if (!_tmp57_) {
						gsize _tmp58_;
						_tmp58_ = i;
						i = _tmp58_ + 1;
					}
					_tmp57_ = FALSE;
					_tmp59_ = i;
					_tmp60_ = n_players;
					if (!(_tmp59_ < _tmp60_)) {
						break;
					}
					_tmp61_ = myself;
					_tmp62_ = i;
					_tmp63_ = n_players;
					p = (TarotPlayer) ((_tmp61_ + _tmp62_) % _tmp63_);
					_tmp64_ = p;
					_tmp65_ = declarant;
					if (_tmp64_ == _tmp65_) {
						GtkListStore* _tmp66_;
						GtkTreeIter _tmp67_;
						gsize _tmp68_;
						_tmp66_ = model;
						_tmp67_ = iter;
						_tmp68_ = i;
						gtk_list_store_set (_tmp66_, &_tmp67_, _tmp68_ - 1, _ ("slam"), -1);
					}
				}
			}
		}
	}
	_tmp69_ = self->priv->current_game;
	_tmp72_ = tarot_game_get_scores_alloc (_tmp69_, &_tmp71_, &_tmp70_);
	scores = (g_free (scores), NULL);
	scores = _tmp70_;
	scores_length1 = _tmp71_;
	_scores_size_ = scores_length1;
	if (_tmp72_ == TAROT_GAME_OK) {
		GtkListStore* _tmp73_;
		GtkTreeIter _tmp74_ = {0};
		_tmp73_ = model;
		gtk_list_store_append (_tmp73_, &_tmp74_);
		iter = _tmp74_;
		{
			gsize i = 0UL;
			i = (gsize) 1;
			{
				gboolean _tmp75_ = FALSE;
				_tmp75_ = TRUE;
				while (TRUE) {
					gsize _tmp77_;
					gsize _tmp78_;
					TarotPlayer p = 0U;
					TarotPlayer _tmp79_;
					gsize _tmp80_;
					gsize _tmp81_;
					GtkListStore* _tmp82_;
					GtkTreeIter _tmp83_;
					gsize _tmp84_;
					gint* _tmp85_;
					gint _tmp85__length1;
					TarotPlayer _tmp86_;
					gint _tmp87_;
					gchar* _tmp88_;
					gchar* _tmp89_;
					if (!_tmp75_) {
						gsize _tmp76_;
						_tmp76_ = i;
						i = _tmp76_ + 1;
					}
					_tmp75_ = FALSE;
					_tmp77_ = i;
					_tmp78_ = n_players;
					if (!(_tmp77_ < _tmp78_)) {
						break;
					}
					_tmp79_ = myself;
					_tmp80_ = i;
					_tmp81_ = n_players;
					p = (TarotPlayer) ((_tmp79_ + _tmp80_) % _tmp81_);
					_tmp82_ = model;
					_tmp83_ = iter;
					_tmp84_ = i;
					_tmp85_ = scores;
					_tmp85__length1 = scores_length1;
					_tmp86_ = p;
					_tmp87_ = _tmp85_[_tmp86_];
					_tmp88_ = g_strdup_printf ("%i", _tmp87_);
					_tmp89_ = _tmp88_;
					gtk_list_store_set (_tmp82_, &_tmp83_, _tmp84_ - 1, _tmp89_, -1);
					_g_free0 (_tmp89_);
				}
			}
		}
	}
	_tmp90_ = self->priv->player_information_others;
	_tmp91_ = model;
	gtk_tree_view_set_model (_tmp90_, (GtkTreeModel*) _tmp91_);
	_tmp92_ = self->priv->player_information_others;
	_tmp93_ = gtk_tree_view_get_columns (_tmp92_);
	columns = _tmp93_;
	_tmp94_ = columns;
	{
		GList* c_collection = NULL;
		GList* c_it = NULL;
		c_collection = _tmp94_;
		for (c_it = c_collection; c_it != NULL; c_it = c_it->next) {
			GtkTreeViewColumn* c = NULL;
			c = (GtkTreeViewColumn*) c_it->data;
			{
				GtkTreeView* _tmp95_;
				GtkTreeViewColumn* _tmp96_;
				_tmp95_ = self->priv->player_information_others;
				_tmp96_ = c;
				gtk_tree_view_remove_column (_tmp95_, _tmp96_);
			}
		}
	}
	_tmp97_ = self->priv->current_game;
	tarot_game_get_taker (_tmp97_, &_tmp98_);
	taker = _tmp98_;
	_tmp99_ = self->priv->current_game;
	_tmp101_ = tarot_game_get_partner (_tmp99_, &_tmp100_);
	partner = _tmp100_;
	has_partner = _tmp101_ == TAROT_GAME_OK;
	{
		gsize i = 0UL;
		i = (gsize) 0;
		{
			gboolean _tmp102_ = FALSE;
			_tmp102_ = TRUE;
			while (TRUE) {
				gsize _tmp104_;
				gsize _tmp105_;
				TarotPlayer p = 0U;
				TarotPlayer _tmp106_;
				gsize _tmp107_;
				gsize _tmp108_;
				GtkCellRendererText* renderer = NULL;
				GtkCellRendererText* _tmp109_;
				TarotPlayer _tmp110_;
				TarotPlayer _tmp111_;
				GtkCellRendererText* _tmp120_;
				GtkTreeViewColumn* column = NULL;
				TarotPlayer _tmp121_;
				gchar* _tmp122_;
				gchar* _tmp123_;
				GtkCellRendererText* _tmp124_;
				gsize _tmp125_;
				GtkTreeViewColumn* _tmp126_;
				GtkTreeViewColumn* _tmp127_;
				GtkTreeViewColumn* _tmp128_;
				GtkTreeViewColumn* _tmp129_;
				GtkTreeView* _tmp130_;
				GtkTreeViewColumn* _tmp131_;
				if (!_tmp102_) {
					gsize _tmp103_;
					_tmp103_ = i;
					i = _tmp103_ + 1;
				}
				_tmp102_ = FALSE;
				_tmp104_ = i;
				_tmp105_ = n_players;
				if (!((_tmp104_ + 1) < _tmp105_)) {
					break;
				}
				_tmp106_ = myself;
				_tmp107_ = i;
				_tmp108_ = n_players;
				p = (TarotPlayer) (((_tmp106_ + _tmp107_) + 1) % _tmp108_);
				_tmp109_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
				g_object_ref_sink (_tmp109_);
				renderer = _tmp109_;
				_tmp110_ = taker;
				_tmp111_ = p;
				if (_tmp110_ == _tmp111_) {
					GtkCellRendererText* _tmp112_;
					GtkCellRendererText* _tmp113_;
					_tmp112_ = renderer;
					g_object_set (_tmp112_, "background", "#a40000", NULL);
					_tmp113_ = renderer;
					g_object_set (_tmp113_, "foreground", "#eeeeec", NULL);
				} else {
					gboolean _tmp114_ = FALSE;
					gboolean _tmp115_;
					_tmp115_ = has_partner;
					if (_tmp115_) {
						TarotPlayer _tmp116_;
						TarotPlayer _tmp117_;
						_tmp116_ = partner;
						_tmp117_ = p;
						_tmp114_ = _tmp116_ == _tmp117_;
					} else {
						_tmp114_ = FALSE;
					}
					if (_tmp114_) {
						GtkCellRendererText* _tmp118_;
						GtkCellRendererText* _tmp119_;
						_tmp118_ = renderer;
						g_object_set (_tmp118_, "background", "#c4a000", NULL);
						_tmp119_ = renderer;
						g_object_set (_tmp119_, "foreground", "#2e3436", NULL);
					}
				}
				_tmp120_ = renderer;
				g_object_set (_tmp120_, "alignment", PANGO_ALIGN_CENTER, NULL);
				_tmp121_ = p;
				_tmp122_ = tarot_player_to_string_alloc (_tmp121_);
				_tmp123_ = _tmp122_;
				_tmp124_ = renderer;
				_tmp125_ = i;
				_tmp126_ = gtk_tree_view_column_new_with_attributes (_tmp123_, (GtkCellRenderer*) _tmp124_, "text", _tmp125_, NULL, NULL);
				g_object_ref_sink (_tmp126_);
				_tmp127_ = _tmp126_;
				_g_free0 (_tmp123_);
				column = _tmp127_;
				_tmp128_ = column;
				gtk_tree_view_column_set_expand (_tmp128_, TRUE);
				_tmp129_ = column;
				gtk_tree_view_column_set_alignment (_tmp129_, (gfloat) 0.5);
				_tmp130_ = self->priv->player_information_others;
				_tmp131_ = column;
				gtk_tree_view_append_column (_tmp130_, _tmp131_);
				_g_object_unref0 (column);
				_g_object_unref0 (renderer);
			}
		}
	}
	_tmp132_ = self->priv->player_information_others;
	gtk_widget_show ((GtkWidget*) _tmp132_);
	(columns == NULL) ? NULL : (columns = (g_list_free (columns), NULL));
	scores = (g_free (scores), NULL);
	bids = (g_free (bids), NULL);
	_g_object_unref0 (model);
	types = (g_free (types), NULL);
}


static TarotCard*
tarot_widget_trick_content_aux (TarotWidget* self,
                                TarotPlayer view,
                                TarotPlayer* trick_taker,
                                gsize trick,
                                int* result_length1)
{
	TarotPlayer _vala_trick_taker = 0U;
	TarotCard* result = NULL;
	gsize n_players = 0UL;
	TarotGame* _tmp0_;
	TarotCard* cards_trick = NULL;
	gsize _tmp1_;
	TarotCard* _tmp2_;
	gint cards_trick_length1;
	gint _cards_trick_size_;
	TarotGameCardAnalysis* trick_content = NULL;
	TarotGameCardAnalysis* _tmp3_;
	gint trick_content_length1;
	gint _trick_content_size_;
	TarotPlayer trick_leader = 0U;
	gboolean has_trick_content = FALSE;
	TarotGame* _tmp4_;
	TarotGameCardAnalysis* _tmp5_ = NULL;
	gsize _tmp6_;
	TarotGameError _tmp7_;
	gboolean has_trick_leader = FALSE;
	TarotGame* _tmp8_;
	TarotPlayer _tmp9_ = 0U;
	TarotGameError _tmp10_;
	TarotGame* _tmp11_;
	TarotPlayer _tmp12_ = 0U;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_trick_taker = (TarotPlayer) 42;
	_tmp0_ = self->priv->current_game;
	n_players = tarot_game_n_players (_tmp0_);
	_tmp1_ = n_players;
	_tmp2_ = g_new0 (TarotCard, _tmp1_);
	cards_trick = _tmp2_;
	cards_trick_length1 = _tmp1_;
	_cards_trick_size_ = cards_trick_length1;
	_tmp3_ = g_new0 (TarotGameCardAnalysis, 0);
	trick_content = _tmp3_;
	trick_content_length1 = 0;
	_trick_content_size_ = trick_content_length1;
	_tmp4_ = self->priv->current_game;
	_tmp7_ = tarot_game_get_trick_cards_alloc (_tmp4_, trick, &_tmp6_, &_tmp5_);
	trick_content = (g_free (trick_content), NULL);
	trick_content = _tmp5_;
	trick_content_length1 = _tmp6_;
	_trick_content_size_ = trick_content_length1;
	has_trick_content = _tmp7_ == TAROT_GAME_OK;
	_tmp8_ = self->priv->current_game;
	_tmp10_ = tarot_game_get_trick_leader (_tmp8_, trick, &_tmp9_);
	trick_leader = _tmp9_;
	has_trick_leader = _tmp10_ == TAROT_GAME_OK;
	_tmp11_ = self->priv->current_game;
	tarot_game_get_trick_taker (_tmp11_, trick, &_tmp12_);
	_vala_trick_taker = _tmp12_;
	_tmp14_ = has_trick_content;
	if (_tmp14_) {
		gboolean _tmp15_;
		_tmp15_ = has_trick_leader;
		_tmp13_ = _tmp15_;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		TarotCard* card_of = NULL;
		gsize _tmp22_;
		TarotCard* _tmp23_;
		gint card_of_length1;
		gint _card_of_size_;
		TarotGameCardAnalysis* _tmp30_;
		gint _tmp30__length1;
		gsize _tmp31_;
		TarotCard* _tmp56_;
		gint _tmp56__length1;
		{
			gsize i = 0UL;
			i = (gsize) 0;
			{
				gboolean _tmp16_ = FALSE;
				_tmp16_ = TRUE;
				while (TRUE) {
					gsize _tmp18_;
					gsize _tmp19_;
					TarotCard* _tmp20_;
					gint _tmp20__length1;
					gsize _tmp21_;
					if (!_tmp16_) {
						gsize _tmp17_;
						_tmp17_ = i;
						i = _tmp17_ + 1;
					}
					_tmp16_ = FALSE;
					_tmp18_ = i;
					_tmp19_ = n_players;
					if (!(_tmp18_ < _tmp19_)) {
						break;
					}
					_tmp20_ = cards_trick;
					_tmp20__length1 = cards_trick_length1;
					_tmp21_ = i;
					_tmp20_[_tmp21_] = (TarotCard) 79;
				}
			}
		}
		_tmp22_ = n_players;
		_tmp23_ = g_new0 (TarotCard, _tmp22_);
		card_of = _tmp23_;
		card_of_length1 = _tmp22_;
		_card_of_size_ = card_of_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp24_ = FALSE;
				_tmp24_ = TRUE;
				while (TRUE) {
					gint _tmp26_;
					gsize _tmp27_;
					TarotCard* _tmp28_;
					gint _tmp28__length1;
					gint _tmp29_;
					if (!_tmp24_) {
						gint _tmp25_;
						_tmp25_ = i;
						i = _tmp25_ + 1;
					}
					_tmp24_ = FALSE;
					_tmp26_ = i;
					_tmp27_ = n_players;
					if (!(((gsize) _tmp26_) < _tmp27_)) {
						break;
					}
					_tmp28_ = card_of;
					_tmp28__length1 = card_of_length1;
					_tmp29_ = i;
					_tmp28_[_tmp29_] = (TarotCard) 79;
				}
			}
		}
		_tmp30_ = trick_content;
		_tmp30__length1 = trick_content_length1;
		_tmp31_ = n_players;
		_vala_assert (((gsize) _tmp30__length1) <= _tmp31_, "trick_content.length <= n_players");
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp32_ = FALSE;
				_tmp32_ = TRUE;
				while (TRUE) {
					gint _tmp34_;
					TarotGameCardAnalysis* _tmp35_;
					gint _tmp35__length1;
					gsize p = 0UL;
					TarotPlayer _tmp36_;
					gint _tmp37_;
					gsize _tmp38_;
					TarotCard* _tmp39_;
					gint _tmp39__length1;
					gsize _tmp40_;
					TarotGameCardAnalysis* _tmp41_;
					gint _tmp41__length1;
					gint _tmp42_;
					TarotGameCardAnalysis _tmp43_;
					TarotCard _tmp44_;
					if (!_tmp32_) {
						gint _tmp33_;
						_tmp33_ = i;
						i = _tmp33_ + 1;
					}
					_tmp32_ = FALSE;
					_tmp34_ = i;
					_tmp35_ = trick_content;
					_tmp35__length1 = trick_content_length1;
					if (!(_tmp34_ < _tmp35__length1)) {
						break;
					}
					_tmp36_ = trick_leader;
					_tmp37_ = i;
					_tmp38_ = n_players;
					p = (_tmp36_ + _tmp37_) % _tmp38_;
					_tmp39_ = card_of;
					_tmp39__length1 = card_of_length1;
					_tmp40_ = p;
					_tmp41_ = trick_content;
					_tmp41__length1 = trick_content_length1;
					_tmp42_ = i;
					_tmp43_ = _tmp41_[_tmp42_];
					_tmp44_ = _tmp43_.card;
					_tmp39_[_tmp40_] = _tmp44_;
				}
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp45_ = FALSE;
				_tmp45_ = TRUE;
				while (TRUE) {
					gint _tmp47_;
					gsize _tmp48_;
					TarotPlayer p = 0U;
					gint _tmp49_;
					gsize _tmp50_;
					TarotCard* _tmp51_;
					gint _tmp51__length1;
					gint _tmp52_;
					TarotCard* _tmp53_;
					gint _tmp53__length1;
					TarotPlayer _tmp54_;
					TarotCard _tmp55_;
					if (!_tmp45_) {
						gint _tmp46_;
						_tmp46_ = i;
						i = _tmp46_ + 1;
					}
					_tmp45_ = FALSE;
					_tmp47_ = i;
					_tmp48_ = n_players;
					if (!(((gsize) _tmp47_) < _tmp48_)) {
						break;
					}
					_tmp49_ = i;
					_tmp50_ = n_players;
					p = (TarotPlayer) (((gsize) (view + _tmp49_)) % _tmp50_);
					_tmp51_ = cards_trick;
					_tmp51__length1 = cards_trick_length1;
					_tmp52_ = i;
					_tmp53_ = card_of;
					_tmp53__length1 = card_of_length1;
					_tmp54_ = p;
					_tmp55_ = _tmp53_[_tmp54_];
					_tmp51_[_tmp52_] = _tmp55_;
				}
			}
		}
		_tmp56_ = cards_trick;
		_tmp56__length1 = cards_trick_length1;
		if (result_length1) {
			*result_length1 = _tmp56__length1;
		}
		result = _tmp56_;
		card_of = (g_free (card_of), NULL);
		trick_content = (g_free (trick_content), NULL);
		if (trick_taker) {
			*trick_taker = _vala_trick_taker;
		}
		return result;
	} else {
		TarotCard* _tmp57_;
		TarotCard* _tmp58_;
		gint _tmp58__length1;
		_tmp57_ = g_new0 (TarotCard, 0);
		_tmp58_ = _tmp57_;
		_tmp58__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp58__length1;
		}
		result = _tmp58_;
		trick_content = (g_free (trick_content), NULL);
		cards_trick = (g_free (cards_trick), NULL);
		if (trick_taker) {
			*trick_taker = _vala_trick_taker;
		}
		return result;
	}
	trick_content = (g_free (trick_content), NULL);
	cards_trick = (g_free (cards_trick), NULL);
	if (trick_taker) {
		*trick_taker = _vala_trick_taker;
	}
}


static TarotCard*
tarot_widget_trick_content (TarotWidget* self,
                            TarotPlayer view,
                            TarotPlayer* trick_taker,
                            int* result_length1)
{
	TarotPlayer _vala_trick_taker = 0U;
	TarotCard* result = NULL;
	gsize current_trick = 0UL;
	gboolean has_current_trick = FALSE;
	TarotGame* _tmp0_;
	gsize _tmp1_ = 0UL;
	TarotGameError _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp8_;
	TarotGameCardAnalysis* trick_content = NULL;
	TarotGameCardAnalysis* _tmp10_;
	gint trick_content_length1;
	gint _trick_content_size_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_;
	gboolean has_trick_content = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	TarotPlayer my_trick_taker = 0U;
	TarotCard* ret = NULL;
	gsize _tmp24_;
	TarotPlayer _tmp25_ = 0U;
	gint _tmp26_ = 0;
	TarotCard* _tmp27_;
	gint ret_length1;
	gint _ret_size_;
	TarotCard* _tmp28_;
	gint _tmp28__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_trick_taker = (TarotPlayer) 42;
	_tmp0_ = self->priv->current_game;
	_tmp2_ = tarot_game_get_current_trick (_tmp0_, &_tmp1_);
	current_trick = _tmp1_;
	has_current_trick = _tmp2_ == TAROT_GAME_OK;
	_tmp4_ = has_current_trick;
	if (_tmp4_) {
		gsize _tmp5_;
		TarotGame* _tmp6_;
		_tmp5_ = current_trick;
		_tmp6_ = self->priv->current_game;
		_tmp3_ = _tmp5_ >= tarot_game_n_tricks (_tmp6_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gsize _tmp7_;
		_tmp7_ = current_trick;
		current_trick = _tmp7_ - 1;
	}
	_tmp8_ = has_current_trick;
	if (!_tmp8_) {
		TarotGame* _tmp9_;
		_tmp9_ = self->priv->current_game;
		current_trick = tarot_game_n_tricks (_tmp9_) - 1;
		has_current_trick = TRUE;
	}
	_tmp10_ = g_new0 (TarotGameCardAnalysis, 0);
	trick_content = _tmp10_;
	trick_content_length1 = 0;
	_trick_content_size_ = trick_content_length1;
	_tmp12_ = has_current_trick;
	if (_tmp12_) {
		TarotGame* _tmp13_;
		gsize _tmp14_;
		TarotGameCardAnalysis* _tmp15_ = NULL;
		gsize _tmp16_;
		TarotGameError _tmp17_;
		_tmp13_ = self->priv->current_game;
		_tmp14_ = current_trick;
		_tmp17_ = tarot_game_get_trick_cards_alloc (_tmp13_, _tmp14_, &_tmp16_, &_tmp15_);
		trick_content = (g_free (trick_content), NULL);
		trick_content = _tmp15_;
		trick_content_length1 = _tmp16_;
		_trick_content_size_ = trick_content_length1;
		_tmp11_ = _tmp17_ == TAROT_GAME_OK;
	} else {
		_tmp11_ = FALSE;
	}
	has_trick_content = _tmp11_;
	_tmp20_ = has_trick_content;
	if (_tmp20_) {
		gsize _tmp21_;
		_tmp21_ = current_trick;
		_tmp19_ = _tmp21_ > ((gsize) 0);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		TarotGameCardAnalysis* _tmp22_;
		gint _tmp22__length1;
		_tmp22_ = trick_content;
		_tmp22__length1 = trick_content_length1;
		_tmp18_ = _tmp22__length1 == 0;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		gsize _tmp23_;
		_tmp23_ = current_trick;
		current_trick = _tmp23_ - 1;
	}
	_tmp24_ = current_trick;
	_tmp27_ = tarot_widget_trick_content_aux (self, view, &_tmp25_, _tmp24_, &_tmp26_);
	my_trick_taker = _tmp25_;
	ret = _tmp27_;
	ret_length1 = _tmp26_;
	_ret_size_ = ret_length1;
	_vala_trick_taker = my_trick_taker;
	_tmp28_ = ret;
	_tmp28__length1 = ret_length1;
	if (result_length1) {
		*result_length1 = _tmp28__length1;
	}
	result = _tmp28_;
	trick_content = (g_free (trick_content), NULL);
	if (trick_taker) {
		*trick_taker = _vala_trick_taker;
	}
	return result;
}


static TarotCard*
tarot_widget_center_content (TarotWidget* self,
                             int* result_length1)
{
	TarotCard* result = NULL;
	TarotCard* foreground = NULL;
	TarotCard* _tmp0_;
	gint foreground_length1;
	gint _foreground_size_;
	TarotGame* _tmp1_;
	TarotCard* _tmp25_;
	gint _tmp25__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (TarotCard, 0);
	foreground = _tmp0_;
	foreground_length1 = 0;
	_foreground_size_ = foreground_length1;
	_tmp1_ = self->priv->current_game;
	if (tarot_game_step (_tmp1_) == TAROT_DISCARD) {
		TarotGame* _tmp2_;
		TarotCard* _tmp3_ = NULL;
		gsize _tmp4_;
		TarotGameError _tmp5_;
		_tmp2_ = self->priv->current_game;
		_tmp5_ = tarot_game_get_dog_alloc (_tmp2_, &_tmp4_, &_tmp3_);
		foreground = (g_free (foreground), NULL);
		foreground = _tmp3_;
		foreground_length1 = _tmp4_;
		_foreground_size_ = foreground_length1;
		if (_tmp5_ != TAROT_GAME_OK) {
			_vala_assert (FALSE, "false");
		}
	} else {
		gsize i_trick = 0UL;
		TarotGameCardAnalysis* trick_cards = NULL;
		TarotGameCardAnalysis* _tmp6_;
		gint trick_cards_length1;
		gint _trick_cards_size_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		TarotGame* _tmp11_;
		gsize _tmp12_ = 0UL;
		TarotGameError _tmp13_;
		_tmp6_ = g_new0 (TarotGameCardAnalysis, 0);
		trick_cards = _tmp6_;
		trick_cards_length1 = 0;
		_trick_cards_size_ = trick_cards_length1;
		_tmp11_ = self->priv->current_game;
		_tmp13_ = tarot_game_get_current_trick (_tmp11_, &_tmp12_);
		i_trick = _tmp12_;
		if (_tmp13_ == TAROT_GAME_OK) {
			gsize _tmp14_;
			_tmp14_ = i_trick;
			_tmp10_ = _tmp14_ == ((gsize) 0);
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			TarotGame* _tmp15_;
			gsize _tmp16_;
			TarotGameCardAnalysis* _tmp17_ = NULL;
			gsize _tmp18_;
			TarotGameError _tmp19_;
			_tmp15_ = self->priv->current_game;
			_tmp16_ = i_trick;
			_tmp19_ = tarot_game_get_trick_cards_alloc (_tmp15_, _tmp16_, &_tmp18_, &_tmp17_);
			trick_cards = (g_free (trick_cards), NULL);
			trick_cards = _tmp17_;
			trick_cards_length1 = _tmp18_;
			_trick_cards_size_ = trick_cards_length1;
			_tmp9_ = _tmp19_ == TAROT_GAME_OK;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			TarotGameCardAnalysis* _tmp20_;
			gint _tmp20__length1;
			_tmp20_ = trick_cards;
			_tmp20__length1 = trick_cards_length1;
			_tmp8_ = _tmp20__length1 == 0;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			TarotGame* _tmp21_;
			TarotCard* _tmp22_ = NULL;
			gsize _tmp23_;
			TarotGameError _tmp24_;
			_tmp21_ = self->priv->current_game;
			_tmp24_ = tarot_game_get_public_discard_alloc (_tmp21_, &_tmp23_, &_tmp22_);
			foreground = (g_free (foreground), NULL);
			foreground = _tmp22_;
			foreground_length1 = _tmp23_;
			_foreground_size_ = foreground_length1;
			_tmp7_ = _tmp24_ == TAROT_GAME_OK;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
		}
		trick_cards = (g_free (trick_cards), NULL);
	}
	_tmp25_ = foreground;
	_tmp25__length1 = foreground_length1;
	if (result_length1) {
		*result_length1 = _tmp25__length1;
	}
	result = _tmp25_;
	return result;
}


static void
_vala_array_add6 (TarotCard* * array,
                  int* length,
                  int* size,
                  TarotCard value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (TarotCard, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void
tarot_widget_update (TarotWidget* self)
{
	TarotPlayer myself = 0U;
	TarotGame* _tmp0_;
	TarotPlayer _tmp1_ = 0U;
	TarotGameError _tmp2_;
	TarotCard* my_cards = NULL;
	gint my_cards_length1 = 0;
	gint _my_cards_size_ = 0;
	TarotGame* _tmp3_;
	TarotPlayer _tmp4_;
	TarotCard* _tmp5_ = NULL;
	gsize _tmp6_;
	TarotGameError _tmp7_;
	TarotPlayer taker = 0U;
	TarotCard* dog = NULL;
	TarotCard* _tmp9_;
	gint dog_length1;
	gint _dog_size_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	TarotGame* _tmp13_;
	TarotFanCardView* _tmp39_;
	TarotCard* _tmp40_;
	gint _tmp40__length1;
	TarotPlayer trick_taker = 0U;
	TarotTrickCardView* _tmp41_;
	TarotPlayer _tmp42_;
	TarotPlayer _tmp43_ = 0U;
	gint _tmp44_ = 0;
	TarotCard* _tmp45_;
	TarotCard* _tmp46_;
	gint _tmp46__length1;
	gsize position = 0UL;
	TarotPlayer _tmp47_;
	TarotGame* _tmp48_;
	TarotPlayer _tmp49_;
	TarotGame* _tmp50_;
	gsize* trick_selection = NULL;
	gsize _tmp51_;
	gsize* _tmp52_;
	gint trick_selection_length1;
	gint _trick_selection_size_;
	gsize _tmp53_;
	TarotTrickCardView* _tmp54_;
	gint _tmp55_ = 0;
	TarotCard* _tmp56_;
	TarotCard* _tmp57_;
	gint _tmp57__length1;
	gboolean _tmp58_;
	TarotCenterCardView* _tmp64_;
	gint _tmp65_ = 0;
	TarotCard* _tmp66_;
	TarotCard* _tmp67_;
	gint _tmp67__length1;
	TarotCenterCardView* _tmp68_;
	gint _tmp69_ = 0;
	TarotCard* _tmp70_;
	TarotCard* _tmp71_;
	gint _tmp71__length1;
	gboolean _tmp72_;
	TarotGame* _tmp75_;
	TarotPlayer _tmp76_ = 0U;
	gchar* taker_format = NULL;
	gchar* _tmp77_;
	TarotBid* bids = NULL;
	gint bids_length1 = 0;
	gint _bids_size_ = 0;
	TarotGame* _tmp78_;
	TarotBid* _tmp79_ = NULL;
	gsize _tmp80_;
	TarotGameError _tmp81_;
	TarotPlayer _tmp83_;
	TarotBid* _tmp84_;
	gint _tmp84__length1;
	GtkLabel* _tmp92_;
	gchar* _tmp93_;
	gchar* _tmp94_;
	TarotCard call = 0U;
	TarotPlayer partner = 0U;
	static const gchar* names[79] = {N_ ("A♥"), N_ ("2♥"), N_ ("3♥"), N_ ("4♥"), N_ ("5♥"), N_ ("6♥"), N_ ("7♥"), N_ ("8♥"), N_ ("9♥"), N_ ("10♥"), N_ ("J♥"), N_ ("C♥"), N_ ("Q♥"), N_ ("K♥"), N_ ("A♣"), N_ ("2♣"), N_ ("3♣"), N_ ("4♣"), N_ ("5♣"), N_ ("6♣"), N_ ("7♣"), N_ ("8♣"), N_ ("9♣"), N_ ("10♣"), N_ ("J♣"), N_ ("C♣"), N_ ("Q♣"), N_ ("K♣"), N_ ("A♦"), N_ ("2♦"), N_ ("3♦"), N_ ("4♦"), N_ ("5♦"), N_ ("6♦"), N_ ("7♦"), N_ ("8♦"), N_ ("9♦"), N_ ("10♦"), N_ ("J♦"), N_ ("C♦"), N_ ("Q♦"), N_ ("K♦"), N_ ("A♠"), N_ ("2♠"), N_ ("3♠"), N_ ("4♠"), N_ ("5♠"), N_ ("6♠"), N_ ("7♠"), N_ ("8♠"), N_ ("9♠"), N_ ("10♠"), N_ ("J♠"), N_ ("C♠"), N_ ("Q♠"), N_ ("K♠"), N_ ("1★"), N_ ("2★"), N_ ("3★"), N_ ("4★"), N_ ("5★"), N_ ("6★"), N_ ("7★"), N_ ("8★"), N_ ("9★"), N_ ("10★"), N_ ("11★"), N_ ("12★"), N_ ("13★"), N_ ("14★"), N_ ("15★"), N_ ("16★"), N_ ("17★"), N_ ("18★"), N_ ("19★"), N_ ("20★"), N_ ("21★"), N_ ("EXC"), NULL};
	gboolean _tmp95_ = FALSE;
	TarotGame* _tmp96_;
	TarotCard _tmp97_ = 0U;
	TarotGameError _tmp98_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_game;
	_tmp2_ = tarot_game_get_main_player (_tmp0_, &_tmp1_);
	myself = _tmp1_;
	if (_tmp2_ != TAROT_GAME_OK) {
		myself = (TarotPlayer) 0;
	}
	_tmp3_ = self->priv->current_game;
	_tmp4_ = myself;
	_tmp7_ = tarot_game_get_cards_alloc (_tmp3_, _tmp4_, &_tmp6_, &_tmp5_);
	my_cards = (g_free (my_cards), NULL);
	my_cards = _tmp5_;
	my_cards_length1 = _tmp6_;
	_my_cards_size_ = my_cards_length1;
	if (_tmp7_ != TAROT_GAME_OK) {
		TarotCard* _tmp8_;
		_tmp8_ = g_new0 (TarotCard, 0);
		my_cards = (g_free (my_cards), NULL);
		my_cards = _tmp8_;
		my_cards_length1 = 0;
		_my_cards_size_ = my_cards_length1;
	}
	taker = (TarotPlayer) 42;
	_tmp9_ = g_new0 (TarotCard, 0);
	dog = _tmp9_;
	dog_length1 = 0;
	_dog_size_ = dog_length1;
	_tmp13_ = self->priv->current_game;
	if (tarot_game_step (_tmp13_) == TAROT_DISCARD) {
		TarotGame* _tmp14_;
		TarotPlayer _tmp15_ = 0U;
		TarotGameError _tmp16_;
		_tmp14_ = self->priv->current_game;
		_tmp16_ = tarot_game_get_taker (_tmp14_, &_tmp15_);
		taker = _tmp15_;
		_tmp12_ = _tmp16_ == TAROT_GAME_OK;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		TarotPlayer _tmp17_;
		TarotPlayer _tmp18_;
		_tmp17_ = taker;
		_tmp18_ = myself;
		_tmp11_ = _tmp17_ == _tmp18_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		TarotGame* _tmp19_;
		TarotCard* _tmp20_ = NULL;
		gsize _tmp21_;
		TarotGameError _tmp22_;
		_tmp19_ = self->priv->current_game;
		_tmp22_ = tarot_game_get_dog_alloc (_tmp19_, &_tmp21_, &_tmp20_);
		dog = (g_free (dog), NULL);
		dog = _tmp20_;
		dog_length1 = _tmp21_;
		_dog_size_ = dog_length1;
		_tmp10_ = _tmp22_ == TAROT_GAME_OK;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		gboolean present[78] = {0};
		TarotCard* _tmp27_;
		gint _tmp27__length1;
		TarotCard* _tmp29_;
		gint _tmp29__length1;
		TarotCard* _tmp31_;
		{
			TarotCard i = 0U;
			i = (TarotCard) 0;
			{
				gboolean _tmp23_ = FALSE;
				_tmp23_ = TRUE;
				while (TRUE) {
					TarotCard _tmp25_;
					TarotCard _tmp26_;
					if (!_tmp23_) {
						TarotCard _tmp24_;
						_tmp24_ = i;
						i = _tmp24_ + 1;
					}
					_tmp23_ = FALSE;
					_tmp25_ = i;
					if (!(_tmp25_ < ((TarotCard) 78))) {
						break;
					}
					_tmp26_ = i;
					present[_tmp26_] = FALSE;
				}
			}
		}
		_tmp27_ = my_cards;
		_tmp27__length1 = my_cards_length1;
		{
			TarotCard* c_collection = NULL;
			gint c_collection_length1 = 0;
			gint _c_collection_size_ = 0;
			gint c_it = 0;
			c_collection = _tmp27_;
			c_collection_length1 = _tmp27__length1;
			for (c_it = 0; c_it < _tmp27__length1; c_it = c_it + 1) {
				TarotCard c = 0U;
				c = c_collection[c_it];
				{
					TarotCard _tmp28_;
					_tmp28_ = c;
					present[_tmp28_] = TRUE;
				}
			}
		}
		_tmp29_ = dog;
		_tmp29__length1 = dog_length1;
		{
			TarotCard* c_collection = NULL;
			gint c_collection_length1 = 0;
			gint _c_collection_size_ = 0;
			gint c_it = 0;
			c_collection = _tmp29_;
			c_collection_length1 = _tmp29__length1;
			for (c_it = 0; c_it < _tmp29__length1; c_it = c_it + 1) {
				TarotCard c = 0U;
				c = c_collection[c_it];
				{
					TarotCard _tmp30_;
					_tmp30_ = c;
					present[_tmp30_] = TRUE;
				}
			}
		}
		_tmp31_ = g_new0 (TarotCard, 0);
		my_cards = (g_free (my_cards), NULL);
		my_cards = _tmp31_;
		my_cards_length1 = 0;
		_my_cards_size_ = my_cards_length1;
		{
			TarotCard i = 0U;
			i = (TarotCard) 0;
			{
				gboolean _tmp32_ = FALSE;
				_tmp32_ = TRUE;
				while (TRUE) {
					TarotCard _tmp34_;
					TarotCard _tmp35_;
					gboolean _tmp36_;
					if (!_tmp32_) {
						TarotCard _tmp33_;
						_tmp33_ = i;
						i = _tmp33_ + 1;
					}
					_tmp32_ = FALSE;
					_tmp34_ = i;
					if (!(_tmp34_ < ((TarotCard) 78))) {
						break;
					}
					_tmp35_ = i;
					_tmp36_ = present[_tmp35_];
					if (_tmp36_) {
						TarotCard* _tmp37_;
						gint _tmp37__length1;
						TarotCard _tmp38_;
						_tmp37_ = my_cards;
						_tmp37__length1 = my_cards_length1;
						_tmp38_ = i;
						_vala_array_add6 (&my_cards, &my_cards_length1, &_my_cards_size_, _tmp38_);
					}
				}
			}
		}
	}
	_tmp39_ = self->priv->hand_widget;
	_tmp40_ = my_cards;
	_tmp40__length1 = my_cards_length1;
	tarot_card_view_set_cards ((TarotCardView*) _tmp39_, _tmp40_, _tmp40__length1);
	_tmp41_ = self->priv->trick_widget;
	_tmp42_ = myself;
	_tmp45_ = tarot_widget_trick_content (self, _tmp42_, &_tmp43_, &_tmp44_);
	trick_taker = _tmp43_;
	_tmp46_ = _tmp45_;
	_tmp46__length1 = _tmp44_;
	tarot_card_view_set_cards ((TarotCardView*) _tmp41_, _tmp46_, _tmp44_);
	_tmp46_ = (g_free (_tmp46_), NULL);
	_tmp47_ = trick_taker;
	_tmp48_ = self->priv->current_game;
	_tmp49_ = myself;
	_tmp50_ = self->priv->current_game;
	position = ((_tmp47_ + tarot_game_n_players (_tmp48_)) - _tmp49_) % tarot_game_n_players (_tmp50_);
	_tmp51_ = position;
	_tmp52_ = g_new0 (gsize, 1);
	_tmp52_[0] = _tmp51_;
	trick_selection = _tmp52_;
	trick_selection_length1 = 1;
	_trick_selection_size_ = trick_selection_length1;
	_tmp53_ = position;
	_tmp54_ = self->priv->trick_widget;
	_tmp56_ = tarot_card_view_get_cards ((TarotCardView*) _tmp54_, &_tmp55_);
	_tmp57_ = _tmp56_;
	_tmp57__length1 = _tmp55_;
	_tmp58_ = _tmp53_ < ((gsize) _tmp55_);
	_tmp57_ = (g_free (_tmp57_), NULL);
	if (_tmp58_) {
		TarotTrickCardView* _tmp59_;
		gsize* _tmp60_;
		gint _tmp60__length1;
		_tmp59_ = self->priv->trick_widget;
		_tmp60_ = trick_selection;
		_tmp60__length1 = trick_selection_length1;
		tarot_card_view_set_selection ((TarotCardView*) _tmp59_, _tmp60_, _tmp60__length1);
	} else {
		TarotTrickCardView* _tmp61_;
		gsize* _tmp62_;
		gsize* _tmp63_;
		gint _tmp63__length1;
		_tmp61_ = self->priv->trick_widget;
		_tmp62_ = g_new0 (gsize, 0);
		_tmp63_ = _tmp62_;
		_tmp63__length1 = 0;
		tarot_card_view_set_selection ((TarotCardView*) _tmp61_, _tmp63_, 0);
		_tmp63_ = (g_free (_tmp63_), NULL);
	}
	_tmp64_ = self->priv->center_widget;
	_tmp66_ = tarot_widget_center_content (self, &_tmp65_);
	_tmp67_ = _tmp66_;
	_tmp67__length1 = _tmp65_;
	tarot_card_view_set_cards ((TarotCardView*) _tmp64_, _tmp67_, _tmp65_);
	_tmp67_ = (g_free (_tmp67_), NULL);
	_tmp68_ = self->priv->center_widget;
	_tmp70_ = tarot_card_view_get_cards ((TarotCardView*) _tmp68_, &_tmp69_);
	_tmp71_ = _tmp70_;
	_tmp71__length1 = _tmp69_;
	_tmp72_ = _tmp69_ == 0;
	_tmp71_ = (g_free (_tmp71_), NULL);
	if (_tmp72_) {
		TarotCenterCardView* _tmp73_;
		_tmp73_ = self->priv->center_widget;
		gtk_widget_hide ((GtkWidget*) _tmp73_);
	} else {
		TarotCenterCardView* _tmp74_;
		_tmp74_ = self->priv->center_widget;
		gtk_widget_show ((GtkWidget*) _tmp74_);
	}
	_tmp75_ = self->priv->current_game;
	tarot_game_get_taker (_tmp75_, &_tmp76_);
	taker = _tmp76_;
	_tmp77_ = g_strdup ("%s");
	taker_format = _tmp77_;
	_tmp78_ = self->priv->current_game;
	_tmp81_ = tarot_game_get_bids_alloc (_tmp78_, &_tmp80_, &_tmp79_);
	bids = (g_free (bids), NULL);
	bids = _tmp79_;
	bids_length1 = _tmp80_;
	_bids_size_ = bids_length1;
	if (_tmp81_ != TAROT_GAME_OK) {
		TarotBid* _tmp82_;
		_tmp82_ = g_new0 (TarotBid, 0);
		bids = (g_free (bids), NULL);
		bids = _tmp82_;
		bids_length1 = 0;
		_bids_size_ = bids_length1;
	}
	_tmp83_ = taker;
	_tmp84_ = bids;
	_tmp84__length1 = bids_length1;
	if (_tmp83_ < ((TarotPlayer) _tmp84__length1)) {
		TarotBid* _tmp85_;
		gint _tmp85__length1;
		TarotPlayer _tmp86_;
		TarotBid _tmp87_;
		_tmp85_ = bids;
		_tmp85__length1 = bids_length1;
		_tmp86_ = taker;
		_tmp87_ = _tmp85_[_tmp86_];
		switch (_tmp87_) {
			case TAROT_PASS:
			{
				break;
			}
			case TAROT_TAKE:
			{
				gchar* _tmp88_;
				_tmp88_ = g_strdup (_ ("%s\ntakes"));
				_g_free0 (taker_format);
				taker_format = _tmp88_;
				break;
			}
			case TAROT_PUSH:
			{
				gchar* _tmp89_;
				_tmp89_ = g_strdup (_ ("%s\npushes"));
				_g_free0 (taker_format);
				taker_format = _tmp89_;
				break;
			}
			case TAROT_STRAIGHT_KEEP:
			{
				gchar* _tmp90_;
				_tmp90_ = g_strdup (_ ("%s\nkeeps"));
				_g_free0 (taker_format);
				taker_format = _tmp90_;
				break;
			}
			case TAROT_DOUBLE_KEEP:
			{
				gchar* _tmp91_;
				_tmp91_ = g_strdup (_ ("%s\nkeeps (double)"));
				_g_free0 (taker_format);
				taker_format = _tmp91_;
				break;
			}
			default:
			break;
		}
	}
	_tmp92_ = self->priv->player_information_myself;
	_tmp93_ = tarot_widget_compute_my_status_with_score (self);
	_tmp94_ = _tmp93_;
	gtk_label_set_label (_tmp92_, _tmp94_);
	_g_free0 (_tmp94_);
	tarot_widget_update_header_model (self);
	_tmp96_ = self->priv->current_game;
	_tmp98_ = tarot_game_get_call (_tmp96_, &_tmp97_);
	call = _tmp97_;
	if (_tmp98_ == TAROT_GAME_OK) {
		TarotGame* _tmp99_;
		TarotPlayer _tmp100_ = 0U;
		TarotGameError _tmp101_;
		_tmp99_ = self->priv->current_game;
		_tmp101_ = tarot_game_get_partner (_tmp99_, &_tmp100_);
		partner = _tmp100_;
		_tmp95_ = _tmp101_ != TAROT_GAME_OK;
	} else {
		_tmp95_ = FALSE;
	}
	if (_tmp95_) {
		GtkLabel* _tmp102_;
		TarotCard _tmp103_;
		const gchar* _tmp104_;
		gchar* _tmp105_;
		gchar* _tmp106_;
		GtkLabel* _tmp107_;
		_tmp102_ = self->priv->call_info;
		_tmp103_ = call;
		_tmp104_ = names[(gint) _tmp103_];
		_tmp105_ = g_strdup_printf (_ ("Call: %s"), _ (_tmp104_));
		_tmp106_ = _tmp105_;
		gtk_label_set_label (_tmp102_, _tmp106_);
		_g_free0 (_tmp106_);
		_tmp107_ = self->priv->call_info;
		gtk_widget_show ((GtkWidget*) _tmp107_);
	} else {
		gboolean _tmp108_ = FALSE;
		TarotGame* _tmp109_;
		TarotPlayer _tmp110_ = 0U;
		TarotGameError _tmp111_;
		_tmp109_ = self->priv->current_game;
		_tmp111_ = tarot_game_get_partner (_tmp109_, &_tmp110_);
		partner = _tmp110_;
		if (_tmp111_ == TAROT_GAME_OK) {
			TarotPlayer _tmp112_;
			TarotPlayer _tmp113_;
			_tmp112_ = partner;
			_tmp113_ = myself;
			_tmp108_ = _tmp112_ == _tmp113_;
		} else {
			_tmp108_ = FALSE;
		}
		if (_tmp108_) {
			GtkLabel* _tmp114_;
			TarotCard _tmp115_;
			const gchar* _tmp116_;
			gchar* _tmp117_;
			gchar* _tmp118_;
			GtkLabel* _tmp119_;
			_tmp114_ = self->priv->call_info;
			_tmp115_ = call;
			_tmp116_ = names[(gint) _tmp115_];
			_tmp117_ = g_strdup_printf (_ ("Call: you (%s)"), _ (_tmp116_));
			_tmp118_ = _tmp117_;
			gtk_label_set_label (_tmp114_, _tmp118_);
			_g_free0 (_tmp118_);
			_tmp119_ = self->priv->call_info;
			gtk_widget_show ((GtkWidget*) _tmp119_);
		} else {
			GtkLabel* _tmp120_;
			_tmp120_ = self->priv->call_info;
			gtk_widget_hide ((GtkWidget*) _tmp120_);
		}
	}
	bids = (g_free (bids), NULL);
	_g_free0 (taker_format);
	trick_selection = (g_free (trick_selection), NULL);
	dog = (g_free (dog), NULL);
	my_cards = (g_free (my_cards), NULL);
}


static void
tarot_widget_card_selected (TarotWidget* self,
                            gsize i_card)
{
	TarotCard c = 0U;
	TarotFanCardView* _tmp0_;
	gint _tmp1_ = 0;
	TarotCard* _tmp2_;
	TarotCard* _tmp3_;
	gint _tmp3__length1;
	TarotCard _tmp4_;
	TarotCard _tmp5_;
	TarotGameEvent* e = NULL;
	TarotCard _tmp6_;
	TarotGameEvent* _tmp7_;
	TarotGame* _tmp8_;
	TarotGameEvent* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->hand_widget;
	_tmp2_ = tarot_card_view_get_cards ((TarotCardView*) _tmp0_, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = _tmp3_[i_card];
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	c = _tmp5_;
	_tmp6_ = c;
	_tmp7_ = tarot_game_event_alloc_card (_tmp6_);
	e = _tmp7_;
	_tmp8_ = self->priv->current_game;
	_tmp9_ = e;
	if (tarot_game_check_event (_tmp8_, _tmp9_)) {
		TarotCard _tmp10_;
		_tmp10_ = c;
		g_signal_emit (self, tarot_widget_signals[TAROT_WIDGET_SELECT_CARD_SIGNAL], 0, (guint) _tmp10_);
	} else {
		tarot_widget_no_card_selected (self);
	}
	__vala_TarotGameEvent_free0 (e);
}


static void
tarot_widget_no_card_selected (TarotWidget* self)
{
	gsize* selection = NULL;
	gsize* _tmp0_;
	gint selection_length1;
	gint _selection_size_;
	TarotFanCardView* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gsize, 0);
	selection = _tmp0_;
	selection_length1 = 0;
	_selection_size_ = selection_length1;
	_tmp1_ = self->priv->hand_widget;
	tarot_card_view_set_selection ((TarotCardView*) _tmp1_, selection, selection_length1);
	selection = (g_free (selection), NULL);
}


TarotWidget*
tarot_widget_construct (GType object_type)
{
	TarotWidget * self = NULL;
	self = (TarotWidget*) g_object_new (object_type, NULL);
	return self;
}


TarotWidget*
tarot_widget_new (void)
{
	return tarot_widget_construct (TAROT_TYPE_WIDGET);
}


TarotGame*
tarot_widget_get_game (TarotWidget* self)
{
	TarotGame* result;
	TarotGame* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->current_game;
	result = _tmp0_;
	return result;
}


static TarotGame*
_vala_TarotGame_copy (TarotGame* self)
{
	return g_boxed_copy (tarot_game_get_type (), self);
}


static gpointer
__vala_TarotGame_copy0 (gpointer self)
{
	return self ? _vala_TarotGame_copy (self) : NULL;
}


void
tarot_widget_set_game (TarotWidget* self,
                       TarotGame* value)
{
	TarotGame* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = __vala_TarotGame_copy0 (value);
	__vala_TarotGame_free0 (self->priv->current_game);
	self->priv->current_game = _tmp0_;
	tarot_widget_update (self);
	g_object_notify_by_pspec ((GObject *) self, tarot_widget_properties[TAROT_WIDGET_GAME_PROPERTY]);
}


static void
g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__POINTER_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static gboolean
_tarot_widget___lambda21_ (TarotWidget* self,
                           GdkEventMotion* motion,
                           gsize i_card)
{
	gboolean result = FALSE;
	TarotFanCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->hand_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, &i_card);
}


static gboolean
__tarot_widget___lambda21__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                     GdkEventMotion* motion,
                                                                     gsize index,
                                                                     gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda21_ ((TarotWidget*) self, motion, index);
	return result;
}


static gboolean
_tarot_widget___lambda22_ (TarotWidget* self,
                           GdkEventMotion* motion)
{
	gboolean result = FALSE;
	TarotFanCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->hand_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, NULL);
}


static gboolean
__tarot_widget___lambda22__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                        GdkEventMotion* motion,
                                                                        gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda22_ ((TarotWidget*) self, motion);
	return result;
}


static gboolean
_tarot_widget___lambda23_ (TarotWidget* self,
                           GdkEventMotion* motion,
                           gsize i_card)
{
	gboolean result = FALSE;
	TarotTrickCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->trick_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, &i_card);
}


static gboolean
__tarot_widget___lambda23__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                     GdkEventMotion* motion,
                                                                     gsize index,
                                                                     gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda23_ ((TarotWidget*) self, motion, index);
	return result;
}


static gboolean
_tarot_widget___lambda24_ (TarotWidget* self,
                           GdkEventMotion* motion)
{
	gboolean result = FALSE;
	TarotTrickCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->trick_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, NULL);
}


static gboolean
__tarot_widget___lambda24__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                        GdkEventMotion* motion,
                                                                        gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda24_ ((TarotWidget*) self, motion);
	return result;
}


static gboolean
_tarot_widget___lambda25_ (TarotWidget* self,
                           GdkEventMotion* motion,
                           gsize i_card)
{
	gboolean result = FALSE;
	TarotCenterCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->center_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, &i_card);
}


static gboolean
__tarot_widget___lambda25__tarot_card_view_motion_notify_event_card (TarotCardView* _sender,
                                                                     GdkEventMotion* motion,
                                                                     gsize index,
                                                                     gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda25_ ((TarotWidget*) self, motion, index);
	return result;
}


static gboolean
_tarot_widget___lambda26_ (TarotWidget* self,
                           GdkEventMotion* motion)
{
	gboolean result = FALSE;
	TarotCenterCardView* _tmp0_;
	g_return_val_if_fail (motion != NULL, FALSE);
	_tmp0_ = self->priv->center_widget;
	tarot_card_view_set_pointed ((TarotCardView*) _tmp0_, NULL);
}


static gboolean
__tarot_widget___lambda26__tarot_card_view_motion_notify_event_no_card (TarotCardView* _sender,
                                                                        GdkEventMotion* motion,
                                                                        gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda26_ ((TarotWidget*) self, motion);
	return result;
}


static gboolean
_tarot_widget___lambda27_ (TarotWidget* self,
                           GdkEventButton* button,
                           gsize i_card)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (button != NULL, FALSE);
	_tmp0_ = self->priv->allow_play;
	if (_tmp0_) {
		FILE* _tmp1_;
		_tmp1_ = stderr;
		fprintf (_tmp1_, "allow_play = true\n");
		tarot_widget_card_selected (self, i_card);
	}
}


static gboolean
__tarot_widget___lambda27__tarot_card_view_button_press_event_card (TarotCardView* _sender,
                                                                    GdkEventButton* button,
                                                                    gsize index,
                                                                    gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda27_ ((TarotWidget*) self, button, index);
	return result;
}


static gboolean
_tarot_widget___lambda28_ (TarotWidget* self,
                           GdkEventButton* button)
{
	gboolean result = FALSE;
	g_return_val_if_fail (button != NULL, FALSE);
	tarot_widget_no_card_selected (self);
}


static gboolean
__tarot_widget___lambda28__tarot_card_view_button_press_event_no_card (TarotCardView* _sender,
                                                                       GdkEventButton* button,
                                                                       gpointer self)
{
	gboolean result;
	result = _tarot_widget___lambda28_ ((TarotWidget*) self, button);
	return result;
}


static void
_tarot_widget___lambda29_ (TarotWidget* self,
                           gint n)
{
	if (n == 0) {
		GtkButton* _tmp0_;
		_tmp0_ = self->priv->button_discard;
		gtk_button_set_label (_tmp0_, _ ("Discard"));
	} else {
		if (n < 0) {
			GtkButton* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->button_discard;
			_tmp2_ = g_strdup_printf (_ ("%d cards in excess"), -n);
			_tmp3_ = _tmp2_;
			gtk_button_set_label (_tmp1_, _tmp3_);
			_g_free0 (_tmp3_);
		} else {
			GtkButton* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp4_ = self->priv->button_discard;
			_tmp5_ = g_strdup_printf (_ ("%d..."), n);
			_tmp6_ = _tmp5_;
			gtk_button_set_label (_tmp4_, _tmp6_);
			_g_free0 (_tmp6_);
		}
	}
}


static void
__tarot_widget___lambda29__tarot_card_selection_n_remaining_cards_to_select (TarotCardSelection* _sender,
                                                                             gint n,
                                                                             gpointer self)
{
	_tarot_widget___lambda29_ ((TarotWidget*) self, n);
}


static GObject *
tarot_widget_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TarotWidget * self;
	TarotFanCardView* _tmp0_;
	TarotFanCardView* _tmp1_;
	TarotTrickCardView* _tmp2_;
	TarotTrickCardView* _tmp3_;
	TarotCenterCardView* _tmp4_;
	TarotCenterCardView* _tmp5_;
	TarotFanCardView* _tmp6_;
	TarotFanCardView* _tmp7_;
	TarotCardSelection* _tmp8_;
	GtkFlowBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkStack* _tmp14_;
	parent_class = G_OBJECT_CLASS (tarot_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_WIDGET, TarotWidget);
	_tmp0_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp0_, "motion-notify-event-card", (GCallback) __tarot_widget___lambda21__tarot_card_view_motion_notify_event_card, self, 0);
	_tmp1_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp1_, "motion-notify-event-no-card", (GCallback) __tarot_widget___lambda22__tarot_card_view_motion_notify_event_no_card, self, 0);
	_tmp2_ = self->priv->trick_widget;
	g_signal_connect_object ((TarotCardView*) _tmp2_, "motion-notify-event-card", (GCallback) __tarot_widget___lambda23__tarot_card_view_motion_notify_event_card, self, 0);
	_tmp3_ = self->priv->trick_widget;
	g_signal_connect_object ((TarotCardView*) _tmp3_, "motion-notify-event-no-card", (GCallback) __tarot_widget___lambda24__tarot_card_view_motion_notify_event_no_card, self, 0);
	_tmp4_ = self->priv->center_widget;
	g_signal_connect_object ((TarotCardView*) _tmp4_, "motion-notify-event-card", (GCallback) __tarot_widget___lambda25__tarot_card_view_motion_notify_event_card, self, 0);
	_tmp5_ = self->priv->center_widget;
	g_signal_connect_object ((TarotCardView*) _tmp5_, "motion-notify-event-no-card", (GCallback) __tarot_widget___lambda26__tarot_card_view_motion_notify_event_no_card, self, 0);
	_tmp6_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp6_, "button-press-event-card", (GCallback) __tarot_widget___lambda27__tarot_card_view_button_press_event_card, self, 0);
	_tmp7_ = self->priv->hand_widget;
	g_signal_connect_object ((TarotCardView*) _tmp7_, "button-press-event-no-card", (GCallback) __tarot_widget___lambda28__tarot_card_view_button_press_event_no_card, self, 0);
	_tmp8_ = self->priv->discard_selection;
	g_signal_connect_object (_tmp8_, "n-remaining-cards-to-select", (GCallback) __tarot_widget___lambda29__tarot_card_selection_n_remaining_cards_to_select, self, 0);
	_tmp9_ = self->priv->widget_bid;
	gtk_widget_show ((GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->widget_decl;
	gtk_widget_show ((GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->widget_call;
	gtk_widget_show ((GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->widget_discard;
	gtk_widget_show ((GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->widget_handful;
	gtk_widget_show ((GtkWidget*) _tmp13_);
	_tmp14_ = self->priv->entry_stack;
	gtk_widget_hide ((GtkWidget*) _tmp14_);
	return obj;
}


static void
tarot_widget_class_init (TarotWidgetClass * klass)
{
	tarot_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TarotWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tarot_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tarot_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = tarot_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = tarot_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAROT_WIDGET_GAME_PROPERTY, tarot_widget_properties[TAROT_WIDGET_GAME_PROPERTY] = g_param_spec_boxed ("game", "game", "game", tarot_game_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/eu/planete_kraus/Tarot/widget.ui");
	tarot_widget_signals[TAROT_WIDGET_SELECT_BID_SIGNAL] = g_signal_new ("select-bid", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, tarot_bid_get_type ());
	tarot_widget_signals[TAROT_WIDGET_SELECT_DECLARATION_SIGNAL] = g_signal_new ("select-declaration", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	tarot_widget_signals[TAROT_WIDGET_SELECT_CALL_SIGNAL] = g_signal_new ("select-call", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	tarot_widget_signals[TAROT_WIDGET_SELECT_DISCARD_SIGNAL] = g_signal_new ("select-discard", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
	tarot_widget_signals[TAROT_WIDGET_SELECT_HANDFUL_SIGNAL] = g_signal_new ("select-handful", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
	tarot_widget_signals[TAROT_WIDGET_SELECT_CARD_SIGNAL] = g_signal_new ("select-card", TAROT_TYPE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "trick_widget", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, trick_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "center_widget", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, center_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hand_widget", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, hand_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry_stack", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, entry_stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_bid", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_bid));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_take", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_take));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_push", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_push));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_straight_keep", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_straight_keep));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_double_keep", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_double_keep));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "player_information_myself", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, player_information_myself));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_decl", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_decl));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_slam", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_slam));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_call", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_call));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "call_selection", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, call_selection));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_call", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_call));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_discard", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_discard));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "discard_selection", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, discard_selection));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_discard", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_discard));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "widget_handful", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, widget_handful));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "handful_selection", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, handful_selection));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_handful", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, button_handful));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "player_information_others", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, player_information_others));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "call_info", FALSE, TarotWidget_private_offset + G_STRUCT_OFFSET (TarotWidgetPrivate, call_info));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_pass", G_CALLBACK(_tarot_widget_select_pass_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_take", G_CALLBACK(_tarot_widget_select_take_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_push", G_CALLBACK(_tarot_widget_select_push_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_straight_keep", G_CALLBACK(_tarot_widget_select_straight_keep_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_double_keep", G_CALLBACK(_tarot_widget_select_double_keep_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_none", G_CALLBACK(_tarot_widget_select_none_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "select_slam", G_CALLBACK(_tarot_widget_select_slam_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_call_clicked", G_CALLBACK(_tarot_widget_button_call_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "valid_call_selection", G_CALLBACK(_tarot_widget_valid_call_selection_tarot_card_selection_valid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "invalid_call_selection", G_CALLBACK(_tarot_widget_invalid_call_selection_tarot_card_selection_invalid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_discard_clicked", G_CALLBACK(_tarot_widget_button_discard_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "valid_discard_selection", G_CALLBACK(_tarot_widget_valid_discard_selection_tarot_card_selection_valid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "invalid_discard_selection", G_CALLBACK(_tarot_widget_invalid_discard_selection_tarot_card_selection_invalid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_handful_clicked", G_CALLBACK(_tarot_widget_button_handful_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "valid_handful_selection", G_CALLBACK(_tarot_widget_valid_handful_selection_tarot_card_selection_valid_selection));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "invalid_handful_selection", G_CALLBACK(_tarot_widget_invalid_handful_selection_tarot_card_selection_invalid_selection));
}


static void
tarot_widget_instance_init (TarotWidget * self)
{
	TarotGame* _tmp0_;
	self->priv = tarot_widget_get_instance_private (self);
	self->priv->allow_play = TRUE;
	_tmp0_ = tarot_game_alloc ();
	self->priv->current_game = _tmp0_;
	g_type_ensure (TAROT_TYPE_TRICK_CARD_VIEW);
	g_type_ensure (TAROT_TYPE_CENTER_CARD_VIEW);
	g_type_ensure (TAROT_TYPE_FAN_CARD_VIEW);
	g_type_ensure (TAROT_TYPE_CARD_SELECTION);
	g_type_ensure (TAROT_TYPE_CARD_SELECTION);
	g_type_ensure (TAROT_TYPE_CARD_SELECTION);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
tarot_widget_finalize (GObject * obj)
{
	TarotWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_WIDGET, TarotWidget);
	_g_object_unref0 (self->priv->trick_widget);
	_g_object_unref0 (self->priv->center_widget);
	_g_object_unref0 (self->priv->hand_widget);
	_g_object_unref0 (self->priv->entry_stack);
	_g_object_unref0 (self->priv->widget_bid);
	_g_object_unref0 (self->priv->button_take);
	_g_object_unref0 (self->priv->button_push);
	_g_object_unref0 (self->priv->button_straight_keep);
	_g_object_unref0 (self->priv->button_double_keep);
	_g_object_unref0 (self->priv->player_information_myself);
	_g_object_unref0 (self->priv->widget_decl);
	_g_object_unref0 (self->priv->button_slam);
	_g_object_unref0 (self->priv->widget_call);
	_g_object_unref0 (self->priv->call_selection);
	_g_object_unref0 (self->priv->button_call);
	_g_object_unref0 (self->priv->widget_discard);
	_g_object_unref0 (self->priv->discard_selection);
	_g_object_unref0 (self->priv->button_discard);
	_g_object_unref0 (self->priv->widget_handful);
	_g_object_unref0 (self->priv->handful_selection);
	_g_object_unref0 (self->priv->button_handful);
	__vala_TarotGame_free0 (self->priv->current_game);
	_g_object_unref0 (self->priv->player_information_others);
	_g_object_unref0 (self->priv->call_info);
	G_OBJECT_CLASS (tarot_widget_parent_class)->finalize (obj);
}


GType
tarot_widget_get_type (void)
{
	static volatile gsize tarot_widget_type_id__volatile = 0;
	if (g_once_init_enter (&tarot_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TarotWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotWidget), 0, (GInstanceInitFunc) tarot_widget_instance_init, NULL };
		GType tarot_widget_type_id;
		tarot_widget_type_id = g_type_register_static (gtk_box_get_type (), "TarotWidget", &g_define_type_info, 0);
		TarotWidget_private_offset = g_type_add_instance_private (tarot_widget_type_id, sizeof (TarotWidgetPrivate));
		g_once_init_leave (&tarot_widget_type_id__volatile, tarot_widget_type_id);
	}
	return tarot_widget_type_id__volatile;
}


static void
_vala_tarot_widget_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	TarotWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_WIDGET, TarotWidget);
	switch (property_id) {
		case TAROT_WIDGET_GAME_PROPERTY:
		g_value_set_boxed (value, tarot_widget_get_game (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_tarot_widget_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	TarotWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TAROT_TYPE_WIDGET, TarotWidget);
	switch (property_id) {
		case TAROT_WIDGET_GAME_PROPERTY:
		tarot_widget_set_game (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



